Attribute VB_Name = "Module1"
Type CasActionItem
  email(127) As Byte
  ctx(31) As Byte
  srv(31) As Byte
  dev(63) As Byte
  prp(63) As Byte
  actionSignalString(127) As Byte
  actionSignalFormat As Long
  alarmCode As Long
End Type

Type ALMRECORD
  context As String
  server As String
  Extension As String
  SeverityLevel As Long
  ArchiveLevel As Long
  Retention As Long
  AlarmLevel As Long
  subsystem As String
  alarmSystem As Long
  offline As Long
  stale As Boolean
  actionsAcquired As Boolean
  actions() As CasActionItem
  nactions As Integer
  actionsStale As Boolean
  systemsAcquired As Boolean
  systems() As Long
  nsystems As Integer
  systemsStale As Boolean
  adefs() As ADS
  nadefs As Integer
  adefsAcquired As Boolean
End Type

Type CasDbItem
  devcontext(31) As Byte
  devServer(31) As Byte
  subsystem(15) As Byte
  arcExt(15) As Byte
  SeverityLevel As Long
  ArchiveLevel As Long
  Retention As Long
  AlarmLevel As Long
  alarmSystem As Long
  offline As Long
End Type

Type ALMSYS
  tag As String
  subsystem As String
  number  As Integer
  row As Integer
  column As Integer
End Type

Type CasAlmSysTblEntry
  number As Long
  column As Long
  row As Long
  tag(31) As Byte
  subsystem(15) As Byte
End Type


Global NMachines As Integer

Global dbPaths() As String
Global dbContexts() As String

Sub registerStructs()

AddFieldToStruct "CasDb", 0, 32, CF_TEXT, "devContext"
AddFieldToStruct "CasDb", 32, 32, CF_TEXT, "devServer"
AddFieldToStruct "CasDb", 64, 16, CF_TEXT, "subsystem"
AddFieldToStruct "CasDb", 80, 16, CF_TEXT, "arcExt"
AddFieldToStruct "CasDb", 96, 1, CF_LONG, "SeverityLevel"
AddFieldToStruct "CasDb", 100, 1, CF_LONG, "ArchiveLevel"
AddFieldToStruct "CasDb", 104, 1, CF_LONG, "Retention"
AddFieldToStruct "CasDb", 108, 1, CF_LONG, "AlarmLevel"
AddFieldToStruct "CasDb", 112, 1, CF_LONG, "AlarmSystem"
AddFieldToStruct "CasDb", 116, 1, CF_LONG, "offline"
SealTaggedStruct "CasDb", 120, 200

AddFieldToStruct "CasAlSys", 0, 1, CF_LONG, "number"
AddFieldToStruct "CasAlSys", 4, 1, CF_LONG, "column"
AddFieldToStruct "CasAlSys", 8, 1, CF_LONG, "row"
AddFieldToStruct "CasAlSys", 12, 32, CF_TEXT, "tag"
AddFieldToStruct "CasAlSys", 44, 16, CF_TEXT, "subsystem"
SealTaggedStruct "CasAlSys", 60, 100

AddFieldToStruct "CasAct", 0, 128, CF_TEXT, "email"
AddFieldToStruct "CasAct", 128, 32, CF_TEXT, "ctx"
AddFieldToStruct "CasAct", 160, 32, CF_TEXT, "srv"
AddFieldToStruct "CasAct", 192, 64, CF_TEXT, "dev"
AddFieldToStruct "CasAct", 256, 64, CF_TEXT, "prp"
AddFieldToStruct "CasAct", 320, 128, CF_TEXT, "actionSignalString"
AddFieldToStruct "CasAct", 448, 1, CF_LONG, "actionSignalFormat"
AddFieldToStruct "CasAct", 452, 1, CF_LONG, "alarmCode"
SealTaggedStruct "CasAct", 456, 50

End Sub
Function getAlarmServerInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, pth_col%
Dim fn$

fn$ = App.Path + "\" + fname

NMachines = getDatabaseSize(fn$)
If NMachines = 0 Then
  getAlarmServerInfo = 0
  Exit Function
End If

ReDim dbPaths(NMachines)
ReDim dbContexts(NMachines)

Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      pth_col = colptr(a$, "PATH")
      done = True
    Else
      dbPaths(i%) = getcol(a$, pth_col)
      dbContexts(i%) = getcol(a$, con_col)
      i% = i% + 1
      If i% >= NMachines Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
getAlarmServerInfo = i%
End Function

