VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form almSysMgrForm 
   Caption         =   "Alarm System Display Manager"
   ClientHeight    =   6990
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7665
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6990
   ScaleWidth      =   7665
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton updateButton 
      Caption         =   "Update DB"
      Height          =   375
      Left            =   6120
      TabIndex        =   2
      Top             =   180
      Width           =   1275
   End
   Begin VB.ComboBox alarmServerCombo 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   240
      Width           =   2415
   End
   Begin MSFlexGridLib.MSFlexGrid AlmSysGrid 
      Height          =   6195
      Left            =   180
      TabIndex        =   0
      Top             =   660
      Width           =   7335
      _ExtentX        =   12938
      _ExtentY        =   10927
      _Version        =   393216
      Rows            =   15
      Cols            =   3
      FixedRows       =   0
      FixedCols       =   0
      RowHeightMin    =   100
      BackColor       =   4259584
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      OLEDropMode     =   1
   End
End
Attribute VB_Name = "almSysMgrForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim nAlarmServerContexts As Integer
Dim alarmServerContexts() As String
Dim draggedIndex As Integer
Dim targetContext As String
Dim dupidx As Integer
Function isDuplicateNumber(ByVal index) As Boolean
Dim i As Integer, n As Integer
isDuplicateNumber = False
If index < 0 Or index > nalmsys - 1 Then
  Exit Function
End If
n = AlmSysItem(index).number
For i = 0 To nalmsys - 1
  If i <> index And AlmSysItem(i).number = n Then
    dupidx = i
    isDuplicateNumber = True
    Exit Function
  End If
Next
End Function

Private Sub alarmServerCombo_Click()
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim devName As String
Dim rc As Integer, i As Integer
Dim addtext As String, rectxt As String
defaultContext = alarmServerCombo.text

devName = "/" + alarmServerCombo.text + "/CAS"
ReDim AlmSysItem(100)
retryRecAcq:
dbin.dFormat = CF_NULL
dbout.dArrayLength = 100: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "CasAlSys"
rc = T_EXECLINK(devName, "ALMSYSTEM.DB", dbout, AlmSysItem(0), dbin, 0, CA_READ + CA_RETRY, 3000)
If rc Then
  rc = MsgBox("Unable to acquire alarm system information from " + devName + "!" + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retryRecAcq
  Exit Sub
End If
nalmsys = dbout.dArrayLength

AlmSysGrid.Clear
For n = 0 To nalmsys - 1
  If AlmSysItem(n).number >= 0 Then
    AlmSysGrid.row = AlmSysItem(n).row - 1
    AlmSysGrid.col = AlmSysItem(n).column - 1
    AlmSysGrid.text = BSTR(AlmSysItem(n).tag)
  End If
Next
End Sub


Private Sub AlmSysGrid_Click()
Dim r As Integer, c As Integer
Dim i As Integer, n As Integer

r = AlmSysGrid.row
c = AlmSysGrid.col

For i = 0 To nalmsys - 1
  If r = AlmSysItem(i).row - 1 And _
     c = AlmSysItem(i).column - 1 Then
    Dialog.almsysNameText.text = BSTR(AlmSysItem(i).tag)
    Dialog.almsysNumberText.text = STR(AlmSysItem(i).number)
    selectedIndex = i
    isEdit = True
    Exit For
  End If
Next
If i = nalmsys Then
  n = getSuggestedAlarmSystemNumber()
  Dialog.almsysNameText.text = "(unused)"
  Dialog.almsysNumberText.text = "(unused:" + STR(n) + ")"
  isEdit = False
  selectedIndex = -1
End If
End Sub

Private Sub almsysNameText_Change()

End Sub

Private Sub almsysNumberText_Change()

End Sub


Private Sub AlmSysGrid_DblClick()
Dialog.Show 1
End Sub

Private Sub AlmSysGrid_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim r As Integer, c As Integer, i As Integer
On Error GoTo dragDropError
If Button And 2 Then
  c = Int(x / AlmSysGrid.CellWidth)
  r = Int(y / AlmSysGrid.CellHeight)
  draggedIndex = -1
  For i = 0 To nalmsys - 1
    If r = AlmSysItem(i).row - 1 And _
       c = AlmSysItem(i).column - 1 Then
      draggedIndex = i
      Exit For
    End If
  Next
  AlmSysGrid.OLEDrag
End If
dragDropError:
Exit Sub
End Sub

Private Sub AlmSysGrid_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim c As Integer, r As Integer, i As Integer
c = Int(x / AlmSysGrid.CellWidth)
r = Int(y / AlmSysGrid.CellHeight)
For i = 0 To nalmsys - 1
  If r = AlmSysItem(i).row - 1 And _
     c = AlmSysItem(i).column - 1 Then
    AlmSysGrid.ToolTipText = BSTR(AlmSysItem(i).tag) + " : Alarm System Number " + STR(AlmSysItem(i).number)
    Exit For
  End If
Next

End Sub


Private Sub AlmSysGrid_OLEDragDrop(Data As MSFlexGridLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
Dim r As Integer, c As Integer, i As Integer
Dim droppedIndex As Integer, rc As Integer
droppedIndex = -1
c = Int(x / AlmSysGrid.CellWidth)
r = Int(y / AlmSysGrid.CellHeight)
For i = 0 To nalmsys - 1
  If r = AlmSysItem(i).row - 1 And _
     c = AlmSysItem(i).column - 1 Then
    droppedIndex = i
    Exit For
  End If
Next
AlmSysGrid.row = r
AlmSysGrid.col = c
If droppedIndex >= 0 Then
  If AlmSysItem(droppedIndex).number >= 0 Then
    rc = MsgBox("Remove item : " + BSTR(AlmSysItem(droppedIndex).tag) + " ?", vbOKCancel)
    If rc <> vbOK Then Exit Sub
  End If
End If
paramsStale = True
If draggedIndex >= 0 Then
  AlmSysGrid.text = BSTR(AlmSysItem(draggedIndex).tag)
  i = nalmsys
  AlmSysItem(i).number = AlmSysItem(draggedIndex).number
  MEMCPY AlmSysItem(i).tag(0), AlmSysItem(draggedIndex).tag(0), 32
  MEMCPY AlmSysItem(i).subsystem(0), AlmSysItem(draggedIndex).subsystem(0), 16
  AlmSysItem(i).column = c + 1
  AlmSysItem(i).row = r + 1
  nalmsys = nalmsys + 1
  AlmSysItem(draggedIndex).number = -1
  AlmSysGrid.row = AlmSysItem(draggedIndex).row - 1
  AlmSysGrid.col = AlmSysItem(draggedIndex).column - 1
  AlmSysGrid.text = ""
End If

End Sub

Private Sub AlmSysGrid_OLEStartDrag(Data As MSFlexGridLib.DataObject, AllowedEffects As Long)
Dim ddstr As String

ddstr = STR(draggedIndex)

Data.SetData ddstr, vbCFText
AllowedEffects = 1
End Sub

Private Sub Form_Load()

AlmSysGrid.ColWidth(0) = 2400
AlmSysGrid.ColWidth(1) = 2400
AlmSysGrid.ColWidth(2) = 2400

targetContext = Command

registerStructs
GetAlarmServerContexts

End Sub
Function getSuggestedAlarmSystemNumber() As Integer
Dim i As Integer, n As Integer
n = 100
tryAgain:
For i = 0 To nalmsys - 1
  If AlmSysItem(i).number = n Then
    n = n + 1
    GoTo tryAgain
  End If
Next
getSuggestedAlarmSystemNumber = n
End Function

Sub GetAlarmServerContexts()
Dim rc As Integer, i As Integer
rc = GetEquipmentDeviceContextsForServer("CAS", alarmServerContexts, nAlarmServerContexts)
If rc <> 0 Then
  MsgBox "Cannot acquire alarm server context information!" + vbNewLine + RPCERROR(rc), vbOKOnly, "GetAlarmServerContexts"
  Exit Sub
End If

Dim tgt As Integer
Dim idx As Integer
For i = 0 To nAlarmServerContexts - 1
  alarmServerCombo.AddItem alarmServerContexts(i)
  If alarmServerContexts(i) = targetContext Then idx = i
 ' If alarmServerContexts(i) = "FLASH" Then tgt = i
Next
alarmServerCombo.ListIndex = idx
'alarmServerCombo.ListIndex = tgt
End Sub


Private Sub Form_Unload(Cancel As Integer)
End
End Sub


Private Sub updateButton_Click()
Dim i As Integer, n As Integer, rc As Integer, cc As Integer
Dim msg As String
Dim asys() As CasAlmSysTblEntry
ReDim asys(nalmsys)
For i = 0 To nalmsys - 1
  If AlmSysItem(i).number >= 0 Then
    If isDuplicateNumber(i) Then
      msg = "system: '" + BSTR(AlmSysItem(i).tag) + "' has the same alarm system number as system: '" + BSTR(AlmSysItem(dupidx).tag) + "'"
      msg = msg + vbNewLine + "Please correct this problem before updating the database!"
      MsgBox msg, vbOKOnly
      Exit Sub
    End If
    MEMCPY asys(n).number, AlmSysItem(i).number, 60
    'Debug.Print BSTR(asys(n).tag), asys(n).number, " at ", asys(n).column, asys(n).row
    n = n + 1
  End If
Next
Debug.Print "total : ", n, " was ", nalmsys
Dim mp
mp = MousePointer
MousePointer = MousePointerConstants.vbHourglass

Dim dbout As DBLK, dbin As DBLK
Dim devName As String

devName = "/" + alarmServerCombo.text + "/CAS"
retrySendUpdate:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = n: dbin.dFormat = CF_STRUCT: BARR dbin.dTag, "CasAlSys"
rc = T_EXECLINK(devName, "ALMSYSTEM.DB", dbout, 0, dbin, asys(0), CA_WRITE, 3000)
If rc <> 0 Then
  cc = MsgBox("Could not update database on " + devName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If cc = vbRetry Then GoTo retrySendUpdate
End If
  
ReLoadDatabase

MousePointer = mp
paramsStale = False
End Sub
Sub ReLoadDatabase()
Dim dbout As DBLK, dbin As DBLK
Dim rc As Integer
Dim devName As String
devName = "/" + alarmServerCombo.text + "/CAS"
retrySendReload1:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
rc = T_EXECLINK(devName, "RESTART", dbout, 0, dbin, 0, CA_WRITE, 500)
If rc <> 0 Then
  rc = MsgBox("Could not restart server " + devName + vbNewLine + RPCERROR(rc), vbRetryCancel)
  If rc = vbRetry Then GoTo retrySendReload1
End If
Sleep 2000
alarmServerCombo_Click
End Sub

