Attribute VB_Name = "Globals"
Global DisplayFlag As Integer
Global Const DispLive_Compact = 0
Global Const DispLive_Subgroups = 1
Global Const DispLive_List = 2
Global Const DispLive_Full = 3
Global Const DispArchive = 4
Global Const DispLive_Debug = 5
Global AlmSubSystemToGridCell%(), GridCellToAlmSubSystem%(), ListCheckValue%
Global LastLiveDisplayMode%

Global Const oneDay& = 24& * 3600&
Global Const oneHour& = 3600&

Global BackGray&, BackDGray&, BackLGray&, BackGreen&, BackDGreen&, BackLGreen&
Global BackRed&, BackDRed&, BackLRed&, BackYellow&, BackDYellow&, BackLYellow&

Global GridOverview_Colors&(), GridAlarmSystem_Colors&(), GridAlarms_Colors&()
Global GridSubsystem_Colors&(), GridDeviceServers_Colors&()

Global DeBuggingFlag As Boolean

Global GridText$, GridAnalysisText$, FileText$
Global AlarmCountingMode%, LastAlarmCountingMode%

Global gStartTime As Long, gStopTime As Long
Global DailyStartTime&, DailyStopTime&, DailyPoints%

Global SelectedArchSubSystem$, SelectedArchDeviceServer$, SelectedArchAlmSubSystem$
Global SelectedArchSubSystemIndex%, SelectedArchDeviceServerIndex%, SelectedArchAlmSubSystemIndex%

Global DeviceAlarmDefs() As ADS, NDeviceAlarmDefs%, SelectedDeviceServer$
Global Loading As Boolean
Global GridSortDirection%, GridHeaderText$(2, 1), GridHeaderTextIndex%
Global nAlarmsInGrid%, nAlarmsAnalysis%
Global NAlmsOverview%(1, 4)
Global AnalysisToAlarms%(MAXALARMSstorage)
Global AlarmsToAnalysis%(MAXALARMSstorage)

Global GridIndexToAlarmTable%(MAXALARMSstorage)
Global GridIndexToAlarmIndex%(MAXALARMSstorage)

Global gAlarmTableGrid(MAXALARMSstorage) As XAMS
Global gAlarmTableAnalysis(MAXALARMSstorage) As XAMS

Global SelectedError As AMS, SelectedErrorIndex%
Global Const NMaxSubIndex% = 50
Global Const NMaxSubIndexDisplay% = 5

Type ALMMiscInfoType
    MatchFound As Boolean
    CountThisAlmEventasAlarm As Boolean ' use to COUNT?
    StartTimeStamp As Double
    StartTimeStampUSec As Double
    NewIndex As Integer
    Terminateindex As Integer
    NSubIndex As Integer
    SubIndex(NMaxSubIndex + 1) As Integer ' How many alarms can be "associated" (heartbeat, datachange..) to a SINGLE alarms
    PersistentFlag As Boolean
    OscillateFlag As Boolean
    DataChangeFlag As Boolean
    AlarmSubSystemIndex As Integer
    DeltaT As Long
    DeviceNameStr As String
    DeviceServerStr As String
    AlarmCodeStr As String
    AlarmTag As String
    AlarmText As String
    ' -1 is EMPTY
    ' 1 is END / last occurance of alarm
    ' 2 is NEW / first occurance of alarm (FIRST occurance could be a PERSISTENCE meldung!)
    ' 3 is "persistent" meldung (some before, some after...)
    ' Event-Alarm = 4
    AlmEventIndex As Long
    AlmEventSubIndex As Long
End Type
' Classifications" of "types" of alarms/alarm pairs (z.B. if both STARt and STOP are found....)
Global Const AlmEvent_Terminate = 1
Global Const AlmEvent_TerminateWStart = 2
Global Const AlmEvent_TerminateWOStart = 3
Global Const AlmEvent_TerminateWOStartWNextTERM = 4
Global Const AlmEvent_TerminateWPersistence = 5

Global Const AlmEvent_New = 100
Global Const AlmEvent_NewWTerminate = 101
Global Const AlmEvent_NewWOStop = 102
Global Const AlmEvent_NewWPersistent = 103
Global Const AlmEvent_NewWNextNEW = 104

Global Const AlmEvent_Persistence = 1000
Global Const AlmEvent_PersistenceWStopStart = 1001
Global Const AlmEvent_PersistenceWStop = 1002
Global Const AlmEvent_PersistenceWStart = 1003
Global Const AlmEvent_PersistenceFirstWStop = 1004 ' use THIS alarm as START (first in list)
Global Const AlmEvent_PersistenceLastWStart = 1005 ' use THIS alarm as STOP (last in list)
Global Const AlmEvent_PersistenceWPersistence = 1006

Global Const AlmEvent_Event = 10000

Global Const AlmEvent_Test = 20000

' Flags for "terminated" alarms
'Global Const StopNoStart = -10
'Global Const StopNoStartPersistent = -20
'Global Const StopNoStart_SecondSTOP = -100

Global gAlarmTableMiscInfo() As ALMMiscInfoType
Global gAlarmTableGridMiscInfo(MAXALARMSstorage) As ALMMiscInfoType
Global gAlarmTableAnalysisMiscInfo(MAXALARMSstorage) As ALMMiscInfoType


' Registry function declarations:
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" _
        (ByVal hKey As Long, ByVal lpctstr As String, phKey As Long) _
        As Long
        
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, _
         lpcbValue As Long) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpdwReserved As Long, _
         lpdwType As Long, lpbData As Byte, lpcbValue As Long) As Long

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long



