Attribute VB_Name = "Module1"
Option Explicit

Type AQS
  srvName(19) As Byte
  localTime As Long
  starttime As Long
  systemPollingRate As Long
  numBkgTasks As Integer
  numTotalContracts As Integer
  numTotalClients As Integer
  numTargetContracts As Integer
  numTargetClients As Integer
  numConnections As Integer
  numConnectionTimeouts As Long
  numConnectionArrivals As Long
  numUDPPkts As Long
  numTCPpkts As Long
  numIPXpkts As Long
  numSPXpkts As Long
End Type
Global ActivityQuery As AQS

Type CLNQS
  UserName(15) As Byte
  network(3) As Byte
  node(5) As Byte
  ipxsocket(1) As Byte
  immAddr(5) As Byte
  sockFamily As Integer
  sockPort As Integer
  sockAddr(3) As Byte
  Reserved(7) As Byte
  ncontracts As Integer
  netProtocol As Integer
End Type
Global ClientQuery As CLNQS

Type ControlUsers
  name As String
  hasWriteAccess As Boolean
  controllableFecs() As String
  nControllableFecs As Integer
  stations() As String
  nStations As Integer
  controlledFecs() As String
End Type
Global users(500) As ControlUsers
Global nControlUsers As Integer

Type ControllableFec
  name As String
  clientNameList() As String
  clientAddrList() As String
  allowedUsersList() As String
  allowedNetsList() As String
  aq As AQS
  cq() As CLNQS
  usrs() As NAME16
  nAttachedClients As Integer
  nAllowedUsers As Integer
  activityId As Long
  clientsId As Long
  usersId As Long
  infoPending As Boolean
End Type
Global fecs() As ControllableFec
Global nfecs As Integer

Global contexts() As String
Global ncontexts As Integer
Global aq As AQS
Global cq() As CLNQS
Global fecContext As String
Global fecNames() As String
Global nfecnames As Integer

Function asyncGetClientList(ByVal index As Integer) As Integer
Dim rc As Integer, i As Integer, n As Integer
Dim usrs() As NAME16
Dim dout As DTYPE
Dim din As DTYPE
Dim devnam As String
Static done As Boolean

If Not done Then
  done = True
  registerQueryStructures
End If

fecs(index).infoPending = True
dout.dArrayLength = 1
dout.dFormat = CF_STRUCT
BARR dout.dTag, "AQS"
dout.ddata = CADDR(fecs(index).aq)
din.dArrayLength = 0
din.dFormat = CF_NULL
din.ddata = 0
devnam = "/" + fecContext + "/" + fecs(index).name + "/#0"
i = T_ATTACHLINK(devnam, "ACTIVITY", dout, din, CA_READ, 1000, AddressOf cbActivity, CM_SINGLE)
If i < 0 Then
  asyncGetClientList = -i
  Exit Function
End If
fecs(index).activityId = i
asyncGetClientList = 0
End Function


Sub oldFillinUserTable()
Dim n As Integer, i As Integer, j As Integer, rc As Integer
For i = 0 To nControlUsers - 1
  users(i).nControllableFecs = 0
  users(i).nStations = 0
  users(i).hasWriteAccess = False
Next
nControlUsers = 0
Debug.Print "Check configurations ..."
n = 0
For i = 0 To nfecs - 1
  If Not fecs(i).infoPending Then
    addUsersToControlList fecs(i), Not (useFecNamesCheck.Value > 0)
    n = n + 1
  End If
Next
Debug.Print n, " fecs responded from ", nfecs

UserGrid.Clear
UserGrid.Rows = nControlUsers + 1
UserGrid.Row = 0
UserGrid.col = 0
UserGrid.ColWidth(0) = UserGrid.Width * 0.4
UserGrid.text = "User"
UserGrid.col = 1
UserGrid.ColWidth(1) = UserGrid.Width * 0.6
UserGrid.text = "Rights"
For i = 0 To nControlUsers - 1
  UserGrid.Row = i + 1
  UserGrid.col = 0
  UserGrid.text = users(i).name
  UserGrid.col = 1
  UserGrid.text = IIf(users(i).hasWriteAccess, "can do damage", "is just browsing")
Next


End Sub

Sub oldway()
Dim n As Integer, i As Integer, j As Integer, rc As Integer
Dim usr As String
Dim srvs() As String
Dim nsrvs As Integer
Dim t0 As Long, t1 As Long

Debug.Print "Get Device Server Names ..."
fecContext = contexts(ContextCombo.ListIndex)
n = 0
For i = 0 To nsubs - 1
  rc = GetEquipmentDeviceServers(contexts(ContextCombo.ListIndex), subs(i), srvs(), nsrvs)
  If rc = 0 Then
    For j = 0 To nsrvs - 1
      fecs(n).name = srvs(j)
      n = n + 1
    Next
  End If
Next
nfecs = n

Debug.Print "Get Independent Fec Names ..."
rc = GetFecsFromNameServer(contexts(ContextCombo.ListIndex), fecNames, nfecnames)

Debug.Print "Get Client List information ..."
#If USE_SYNCHRONOUSLY Then
For i = 0 To nfecs - 1
  rc = getClientList(fecs(i))
  If rc = 0 Then
    addUsersToControlList fecs(i)
  Else
  End If
Next
#Else
For i = 0 To nfecs - 1
  asyncGetClientList (i)
Next

Debug.Print "Start waiting ..."
t0 = Utils.UNIXTIME
Do
  DoEvents
  Sleep 20
  t1 = Utils.UNIXTIME
Loop While (t1 < t0 + 3)
#End If

fillInUserTable

End Sub



Sub cbActivity(ByVal ID As Long, ByVal cc As Long)
Dim rc As Integer, i As Integer, n As Integer, index As Integer
Dim usrs() As NAME16
Dim dout As DTYPE
Dim din As DTYPE
Dim devnam As String

For i = 0 To nfecs - 1
  If ID = fecs(i).activityId Then Exit For
Next
If i = nfecs Then Exit Sub
index = i
If cc <> 0 Then
  Debug.Print "activity callback for " + fecs(i).name + " returned " + str(cc)
  fecs(index).infoPending = False
  Exit Sub
End If
ReDim fecs(index).cq(fecs(index).aq.numTotalClients)
dout.dArrayLength = fecs(index).aq.numTotalClients
dout.dFormat = CF_STRUCT
BARR dout.dTag, "CLNQS"
dout.ddata = CADDR(fecs(index).cq(0))
din.dArrayLength = 0
din.dFormat = CF_NULL
din.ddata = 0
devnam = "/" + fecContext + "/" + fecs(index).name + "/#0"
i = T_ATTACHLINK(devnam, "CLIENTS", dout, din, CA_READ, 1000, AddressOf cbClients, CM_SINGLE)
If i < 0 Then Exit Sub
fecs(index).clientsId = i

End Sub

Sub cbClients(ByVal ID As Long, ByVal cc As Long)
Dim rc As Integer, i As Integer, n As Integer, index As Integer
Dim usrs() As NAME16
Dim dout As DTYPE
Dim din As DTYPE
Dim devnam As String

For i = 0 To nfecs - 1
  If ID = fecs(i).clientsId Then Exit For
Next
If i = nfecs Then Exit Sub
index = i
If cc <> 0 Then
  Debug.Print "clients callback for " + fecs(i).name + " returned " + str(cc)
  fecs(index).infoPending = False
  Exit Sub
End If

ReDim fecs(index).clientNameList(fecs(index).aq.numTotalClients)
ReDim fecs(index).clientAddrList(fecs(index).aq.numTotalClients)
For i = 0 To fecs(index).aq.numTotalClients - 1
  fecs(index).clientNameList(i) = BSTR(fecs(index).cq(i).UserName)
  fecs(index).clientAddrList(i) = str(fecs(index).cq(i).sockAddr(0)) + "." + str(fecs(index).cq(i).sockAddr(1)) _
                                  + "." + str(fecs(index).cq(i).sockAddr(2)) + "." + str(fecs(index).cq(i).sockAddr(3))
Next
fecs(index).nAttachedClients = fecs(index).aq.numTotalClients

ReDim fecs(index).usrs(100)
dout.dArrayLength = 100
dout.dFormat = CF_NAME16
BARR dout.dTag, ""
dout.ddata = CADDR(fecs(index).usrs(0))
din.dArrayLength = 0
din.dFormat = CF_NULL
din.ddata = 0
devnam = "/" + fecContext + "/" + fecs(index).name + "/#0"
i = T_ATTACHLINK(devnam, "USERS", dout, din, CA_READ, 1000, AddressOf cbUsers, CM_SINGLE)
If i < 0 Then Exit Sub
fecs(index).usersId = i

End Sub

Sub cbUsers(ByVal ID As Long, ByVal cc As Long)
Dim rc As Integer, i As Integer, n As Integer, index As Integer
Dim usrs() As NAME16
Dim dout As DTYPE
Dim din As DTYPE
Dim devnam As String

For i = 0 To nfecs - 1
  If ID = fecs(i).usersId Then Exit For
Next
If i = nfecs Then Exit Sub
index = i
fecs(index).infoPending = False
If cc <> 0 Then
  Debug.Print "Users callback for " + fecs(index).name + " returned " + str(cc)
  fecs(index).nAllowedUsers = 0
  Exit Sub
End If

For i = 0 To 99
  If fecs(index).usrs(i).nam(0) = 0 Then Exit For
Next
n = i
If n = 0 Then Debug.Print fecs(index).name + " has no users"
ReDim fecs(index).allowedUsersList(n)
For i = 0 To n - 1
 fecs(index).allowedUsersList(i) = BSTR(fecs(index).usrs(i).nam)
Next
fecs(index).nAllowedUsers = n
End Sub


Function getClientList(f As ControllableFec) As Integer
Dim rc As Integer, i As Integer, n As Integer
Dim aq As AQS
Dim cq() As CLNQS
Dim usrs() As NAME16
Dim dout As DBLK
Dim din As DBLK
Dim devnam As String
Static done As Boolean

If Not done Then
  done = True
  registerQueryStructures
End If

dout.dArrayLength = 1
dout.dFormat = CF_STRUCT
BARR dout.dTag, "AQS"
din.dArrayLength = 0
din.dFormat = CF_NULL
devnam = "/" + fecContext + "/" + f.name + "/#0"
rc = EXECLINKEx(devnam, "ACTIVITY", dout, aq, din, 0, CA_READ, 600)
If rc Then
  getClientList = rc
  Exit Function
End If

ReDim cq(aq.numTotalClients)
dout.dArrayLength = aq.numTotalClients
dout.dFormat = CF_STRUCT
BARR dout.dTag, "CLNQS"
rc = EXECLINKEx(devnam, "CLIENTS", dout, cq(0), din, 0, CA_READ, 600)
If rc Then
  getClientList = rc
  Exit Function
End If
ReDim f.clientNameList(aq.numTotalClients)
ReDim f.clientAddrList(aq.numTotalClients)
For i = 0 To aq.numTotalClients - 1
  f.clientNameList(i) = BSTR(cq(i).UserName)
  f.clientAddrList(i) = str(cq(i).sockAddr(0)) + "." + str(cq(i).sockAddr(1)) + "." + str(cq(i).sockAddr(2)) + "." + str(cq(i).sockAddr(3))
Next
f.nAttachedClients = aq.numTotalClients

dout.dArrayLength = 1
dout.dFormat = CF_INTEGER
BARR dout.dTag, ""
rc = EXECLINKEx(devnam, "NUSERS", dout, n, din, 0, CA_READ, 600)
If rc Or n <= 0 Then ' no users list ? => everyone has access !
  getClientList = rc
  ReDim f.allowedUsersList(0)
  f.nAllowedUsers = 0
  Exit Function
End If
ReDim usrs(n)
dout.dArrayLength = n
dout.dFormat = CF_NAME16
BARR dout.dTag, ""
rc = EXECLINKEx(devnam, "USERS", dout, usrs(0), din, 0, CA_READ, 600)
If rc Then
  getClientList = rc
  Exit Function
End If
ReDim f.allowedUsersList(n)
For i = 0 To n - 1
 f.allowedUsersList(i) = BSTR(usrs(i).nam)
Next
f.nAllowedUsers = n
getClientList = 0
End Function

Function isUserFec(ByVal UserName As String) As Boolean
Dim i As Integer
For i = 0 To nfecnames - 1
  If UserName = fecNames(i) Then
    isUserFec = True
    Exit Function
  End If
Next
isUserFec = False
End Function

Sub registerQueryStructures()
FILLSTRUCT "AQS", Len(ActivityQuery), 1, CF_NULL
FILLSTRUCT "CLNQS", Len(ClientQuery), 1, CF_NULL
End Sub

Sub addUsersToControlList(f As ControllableFec, ByVal suppressFecNames As Boolean)
Dim i As Integer, j As Integer, k As Integer
Dim found As Boolean
Static done As Boolean

For i = 0 To f.nAttachedClients - 1
  If Not (suppressFecNames And isUserFec(f.clientNameList(i))) Then
    found = False
    For j = 0 To nControlUsers - 1
      If f.clientNameList(i) = users(j).name Then
        For k = 0 To users(j).nStations - 1
          If users(j).stations(k) = f.clientAddrList(i) Then Exit For
        Next
        If k = users(j).nStations Then
          users(j).stations(users(j).nStations) = f.clientAddrList(i)
          users(j).nStations = users(j).nStations + 1
        End If
        found = True
        Exit For
      End If
    Next
    If Not found And Len(f.clientNameList(i)) > 0 Then
      users(nControlUsers).name = f.clientNameList(i)
      ReDim users(nControlUsers).controllableFecs(nfecs)
      ReDim users(nControlUsers).stations(50)  ' just some large number at the moment ....
      users(nControlUsers).stations(users(nControlUsers).nStations) = f.clientAddrList(i)
      users(nControlUsers).nStations = users(nControlUsers).nStations + 1
      nControlUsers = nControlUsers + 1
    End If
  End If
Next

For i = 0 To f.nAllowedUsers - 1 'UBound(f.allowedUsersList)
  For j = 0 To nControlUsers - 1
    If f.allowedUsersList(i) = users(j).name Then
      users(j).hasWriteAccess = True
      For k = 0 To users(j).nControllableFecs - 1
        If users(j).controllableFecs(k) = f.name Then Exit For
      Next
      If k = users(j).nControllableFecs Then
        users(j).controllableFecs(users(j).nControllableFecs) = f.name
        users(j).nControllableFecs = users(j).nControllableFecs + 1
      End If
    End If
  Next
Next

End Sub

