Attribute VB_Name = "Module1"
Global Const MAXNUMEVENTS = 512
Global Const MAXNUMSTEPS = 512
Global Const cfgfile$ = "pmarchmgr.csv"

Global Const ALL_DEVICES = "__ALL_DEVICES__"
Global Const IGNORE_DEVICES = "__IGNORE_DEVICES__"

Type ARBQS
  trg(63) As Byte
  Ext(15) As Byte
  trgdesc(63) As Byte
  'fwdsrv(63) As Byte
  depthInMonths As Long
  recordEvents As Long
End Type

Type DASQS
  ctx(31) As Byte
  srv(31) As Byte
  prp(63) As Byte
  dev(63) As Byte
  srvArc(31) As Byte
  prpArc(63) As Byte
  infile(15) As Byte
  datTag(15) As Byte
  datTagIn(15) As Byte
  datSiz As Long
  datFmt As Long
  datFmtIn As Long
  access As Long
  wait As Long
  timeout As Long  ' poll target timeout
  value As Long
  mode As Long
  monitorRate As Long
  monitorTime As Long
  ScaleY As Single
  shiftY As Single
End Type

Type TrgElem
  trgItem As ARBQS
  steps() As DASQS
  modified As Boolean
End Type

Type PHS
   srv(31) As Byte
   dev(63) As Byte
   prp(63) As Byte
   dsc(63) As Byte
   format As Integer
   arrayT As Integer
   arraySize As Long
   PreTrigger As Long
   UnitsY(15) As Byte
   UnitsX(15) As Byte
   rangeMinX As Single
   rangeMaxX As Single
   scaleMinY As Single
   scaleMaxY As Single
   samplingRate As Single
   range As Single
End Type
  
Type TrgChn
  ctx(31) As Byte
  srv(31) As Byte
  prp(63) As Byte
  dev(63) As Byte
End Type

Type TrgCmp
  ctx(31) As Byte
  srv(31) As Byte
  trg(63) As Byte
  dsc(63) As Byte
End Type

Type TrgView
  ctx(31) As Byte
  trg(63) As Byte
  dsc(63) As Byte
  file(63) As Byte
  ref As Long
  nComponents As Long
End Type

Global Const dasREAD = 1
Global Const dasWRITE = 2
Global Const dasMATCH = 4
Global Const dasWAIT = 8
Global Const dasSETNUM = 16
Global Const dasPREALLOC = 32  ' this is weird -> get rid of it
Global Const dasFORWARD = 64   ' pipes output data from this step to input data for next step
Global Const dasSERIES = 128
Global Const dasMONITOR = 256
Global Const dasPERSIST = 512

Function GetAccessString(ByVal access As Integer)
Dim s As String
s = ""
If access And 1 Then s = "READ"
If access And 2 Then s = "WRITE"
If access And 4 Then s = s + IIf(Len(s) > 0, "|MATCH", "MATCH")
If access And 8 Then s = s + IIf(Len(s) > 0, "|WAIT", "WAIT")
If access And 16 Then s = s + IIf(Len(s) > 0, "|SETNUM", "SETNUM")
If access And 32 Then s = s + IIf(Len(s) > 0, "|PREALLOC", "PREALLOC")
If access And 64 Then s = s + IIf(Len(s) > 0, "|FORWARD", "FORWARD")
If access And 128 Then s = s + IIf(Len(s) > 0, "|SERIES", "SERIES")
If access And 256 Then s = s + IIf(Len(s) > 0, "|MONITOR", "MONITOR")
If access And 512 Then s = s + IIf(Len(s) > 0, "|PERSIST", "PERSIST")
GetAccessString = s
End Function

Sub GetInputData(ByVal context As String, ByVal filename As String, ByVal fmt As Integer)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, i As Integer
Dim rc As Integer
Dim dev As String
Dim n64(255) As NAME64
Dim ivals(255) As Long
Dim dvals(255) As Single

If fmt < CF_DOUBLE Then fmt = fmt + CF_DOUBLE
Select Case fmt
  Case CF_BYTE, CF_INT16, CF_INT32:
    fmt = CF_INT32
  Case CF_FLOAT, CF_DOUBLE:
    fmt = CF_FLOAT
  Case CF_NAME16, CF_NAME32, CF_NAME48, CF_NAME64:
    fmt = CF_NAME64
  Case Else
    Exit Sub
End Select

retryGetData:
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 256: dbout.dFormat = fmt
dev = "/" + context + "/EVENTSTORE/" + filename
If fmt = CF_INT32 Then
  rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, ivals(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
ElseIf fmt = CF_FLOAT Then
  rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, dvals(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
Else
  rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, n64(0).nam(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
End If
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not acquire Input Data : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryGetData
  End If
  Exit Sub
End If
n = dbout.dArrayLength
Dim a As String, txt As String
txt = ""
For i = 0 To n - 1
  If fmt = CF_INT32 Then
    a = STR(ivals(i))
  ElseIf fmt = CF_FLOAT Then
    a = STR(dvals(i))
  Else
    a = BSTR(n64(i).nam)
  End If
  txt = txt + Trim(a) + vbNewLine
  ArchiveDbForm.InptValuesText.text = txt
Next

End Sub
Function GetModeFromString(ByVal mode As String) As Integer
Dim bmode As Integer
bmode = CM_TIMER
If InStr(mode, "CONNECT") > 0 Then
  bmode = bmode + CM_CONNECT
ElseIf InStr(mode, "NETWORK") > 0 Then
  bmode = bmode + CM_NETWORK
ElseIf InStr(mode, "STREAM") > 0 Then
  bmode = bmode + CM_STREAM
End If
GetModeFromString = bmode

End Function

Function GetModeString(ByVal mode As Integer)
Dim bmode As Integer
Dim s As String
s = ""

bmode = mode And 7
Select Case bmode
  Case 1: s = "SINGLE"
  Case 2: s = "DATACHANGE"
  Case 3: s = "TIMER"
  Case 6: s = "EVENT"
  Case Else: s = "DATACHANGE"
End Select

If mode And 128 Then s = s + "|STREAM"
If mode And 512 Then s = s + "|NETWORK"
If mode And 8192 Then s = s + "|CONNECT"
GetModeString = s

End Function
Sub GetTriggerDataFiles(ByVal context As String, files() As String, nfiles As Integer)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, i As Integer
Dim rc As Integer
Dim dev As String
Dim n16(255) As NAME16

retryGetFiles:
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 256: dbout.dFormat = CF_NAME16
dev = "/" + context + "/EVENTSTORE"
rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATAFILES", dbout, n16(0).nam(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not acquire Data Files : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryGetFiles
  End If
  Exit Sub
End If
n = dbout.dArrayLength
If rc <> 0 Then n = 0
nfiles = n
If n = 0 Then Exit Sub
ReDim files(n - 1)
For i = 0 To n - 1
  files(i) = BSTR(n16(i).nam)
Next

End Sub
Sub GetTriggerDb(ByVal context As String, trigger As TrgElem)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, i As Integer
Dim rc As Integer
Dim dev As String
Dim das(255) As DASQS

retryGetDb:
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 100: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "DASQS"
dev = "/" + context + "/EVENTSTORE/" + BSTR(trigger.trgItem.trg)
rc = T_EXECLINK(dev, "TRIGGER.DB", dbout, das(0).ctx(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not acquire Trigger database : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryGetDb
  End If
  Exit Sub
End If
n = dbout.dArrayLength
ReDim trigger.steps(n - 1)
For i = 0 To n - 1
  trigger.steps(i) = das(i)
Next
End Sub

Sub GetTriggerTable(ByVal context As String, trgTbl() As TrgElem, trgTblSize As Integer)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, i As Integer
Dim rc As Integer
Dim dev As String
Dim arb(255) As ARBQS

retryGetTable:
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 256: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "ARBQS"
dev = "/" + context + "/EVENTSTORE"
rc = T_EXECLINK(dev, "TRIGGER.TBL", dbout, arb(0).trg(0), dbin, Null, CA_READ + CA_MUTABLE, 800)
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not acquire Trigger Table : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryGetTable
  End If
  Exit Sub
End If
n = dbout.dArrayLength
If n > 0 Then
  ReDim trgTbl(n - 1)
  For i = 0 To n - 1
    trgTbl(i).trgItem = arb(i)
  Next
Else
  ReDim trgTbl(0)
End If
trgTblSize = n
End Sub
Sub putInputData(ByVal context As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, i As Integer, fmt As Integer
Dim rc As Integer
Dim dev As String
Dim n16() As NAME16
Dim n32() As NAME32
Dim n64() As NAME64
Dim bvals() As Byte
Dim svals() As Integer
Dim ivals() As Long
Dim fvals() As Single
Dim dvals() As Double
Dim vals() As String

fmt = getFormatFromString(ArchiveDbForm.inptFmtList.text)
If fmt < CF_DOUBLE Then fmt = fmt + CF_DOUBLE
vals = Split(ArchiveDbForm.InptValuesText.text, vbNewLine)
n = UBound(vals)

dev = "/" + context + "/EVENTSTORE/" + ArchiveDbForm.inptFileNameCombo.text
retryPutData:
dbin.dArrayLength = n + 1: dbin.dFormat = fmt
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL

Select Case fmt
  Case CF_BYTE:
    ReDim bvals(n)
    For i = 0 To n: bvals(i) = Val(vals(i)): Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, bvals(0), CA_WRITE, 800)
  Case CF_INT16:
    ReDim svals(n)
    For i = 0 To n: svals(i) = Val(vals(i)): Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, svals(0), CA_WRITE, 800)
  Case CF_INT32:
    ReDim ivals(n)
    For i = 0 To n: ivals(i) = Val(vals(i)): Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, ivals(0), CA_WRITE, 800)
  Case CF_FLOAT:
    ReDim fvals(n)
    For i = 0 To n: fvals(i) = Val(vals(i)): Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, fvals(0), CA_WRITE, 800)
  Case CF_DOUBLE:
    ReDim dvals(n)
    For i = 0 To n: dvals(i) = Val(vals(i)): Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, dvals(0), CA_WRITE, 800)
  Case CF_NAME16:
    ReDim n16(n)
    For i = 0 To n
      BARR n16(i).nam, vals(i)
    Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, n16(0), CA_WRITE, 800)
  Case CF_NAME32:
    ReDim n32(n)
    For i = 0 To n
      BARR n32(i).nam, vals(i)
    Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, n32(0), CA_WRITE, 800)
  Case CF_NAME64:
    ReDim n64(n)
    For i = 0 To n
      BARR n64(i).nam, vals(i)
    Next
    rc = T_EXECLINK(dev, "TRIGGER.ITEM.DATA", dbout, Null, dbin, n64(0), CA_WRITE, 800)
  Case Else
    Exit Sub
End Select
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not send input data: " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryPutData
  End If
  Exit Sub
End If

End Sub

Sub PutTriggerTable(ByVal context As String, trgTbl() As TrgElem)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, i As Integer, k As Integer
Dim rc As Integer
Dim dev As String
Dim arb(255) As ARBQS
Dim tbl() As ARBQS

n = UBound(trgTbl)
If n < 0 Then Exit Sub
ReDim tbl(n)
For i = 0 To n
  If trgTbl(i).modified Then
      tbl(k) = trgTbl(i).trgItem
      k = k + 1
  End If
Next

retryPutTable:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = k: dbin.dFormat = CF_STRUCT: BARR dbin.dTag, "ARBQS"
dev = "/" + context + "/EVENTSTORE"
rc = T_EXECLINK(dev, "TRIGGER.TBL", dbout, vbNull, dbin, tbl(0).trg(0), CA_WRITE, 800)
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not send Trigger Table : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryPutTable
  End If
  Exit Sub
End If

For i = 0 To n
  If trgTbl(i).modified Then
retryPutDb:
    dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
    dbin.dArrayLength = UBound(trgTbl(i).steps) + 1: dbin.dFormat = CF_STRUCT: BARR dbin.dTag, "DASQS"
    dev = "/" + context + "/EVENTSTORE/" + BSTR(trgTbl(i).trgItem.trg)
    rc = T_EXECLINK(dev, "TRIGGER.DB", dbout, vbNull, dbin, trgTbl(i).steps(0), CA_WRITE, 800)
    If rc = link_not_open Or rc = connection_timeout Then
      If MsgBox("Could not send Trigger database : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
        GoTo retryPutDb
      End If
      Exit Sub
    End If
  End If
  trgTbl(i).modified = False
Next

End Sub
Sub registerStructs()
AddFieldToStruct "ARBQS", 0, 64, CF_TEXT, "eventTrigger"
'AddFieldToStruct "ARBQS", 0, 64, CF_TEXT, "eventContext"
AddFieldToStruct "ARBQS", 64, 16, CF_TEXT, "eventExtension"
AddFieldToStruct "ARBQS", 80, 64, CF_TEXT, "description"
'AddFieldToStruct "ARBQS", 80, 64, CF_TEXT, "forward"
AddFieldToStruct "ARBQS", 144, 1, CF_LONG, "purgeDepth"
AddFieldToStruct "ARBQS", 148, 1, CF_LONG, "recordFlag"
SealTaggedStruct "ARBQS", 152, 256

AddFieldToStruct "DASQS", 0, 32, CF_TEXT, "context"
AddFieldToStruct "DASQS", 32, 32, CF_TEXT, "server"
AddFieldToStruct "DASQS", 64, 64, CF_TEXT, "property"
AddFieldToStruct "DASQS", 128, 64, CF_TEXT, "device"
AddFieldToStruct "DASQS", 192, 32, CF_TEXT, "serverArchive"
AddFieldToStruct "DASQS", 224, 64, CF_TEXT, "propertyArchive"
AddFieldToStruct "DASQS", 288, 16, CF_TEXT, "inputFile"

AddFieldToStruct "DASQS", 304, 16, CF_TEXT, "dataTag"
AddFieldToStruct "DASQS", 320, 16, CF_TEXT, "dataTagInput"

AddFieldToStruct "DASQS", 336, 1, CF_LONG, "dataSize"
AddFieldToStruct "DASQS", 340, 1, CF_LONG, "format"
AddFieldToStruct "DASQS", 344, 1, CF_LONG, "formatInput"
AddFieldToStruct "DASQS", 348, 1, CF_LONG, "access"
AddFieldToStruct "DASQS", 352, 1, CF_LONG, "waitTime"
AddFieldToStruct "DASQS", 356, 1, CF_LONG, "timeout"
AddFieldToStruct "DASQS", 360, 1, CF_LONG, "value"
AddFieldToStruct "DASQS", 364, 1, CF_LONG, "mode"
AddFieldToStruct "DASQS", 368, 1, CF_LONG, "monitorRate"
AddFieldToStruct "DASQS", 372, 1, CF_LONG, "monitorTime"
AddFieldToStruct "DASQS", 376, 1, CF_FLOAT, "scale"
AddFieldToStruct "DASQS", 380, 1, CF_FLOAT, "shift"
SealTaggedStruct "DASQS", 384, 100

AddFieldToStruct "PHSr4", 0, 32, CF_TEXT, "server"
AddFieldToStruct "PHSr4", 32, 64, CF_TEXT, "device"
AddFieldToStruct "PHSr4", 96, 64, CF_TEXT, "property"
AddFieldToStruct "PHSr4", 160, 64, CF_TEXT, "description"
AddFieldToStruct "PHSr4", 224, 1, CF_INT16, "format"
AddFieldToStruct "PHSr4", 226, 1, CF_INT16, "arrayType"
AddFieldToStruct "PHSr4", 228, 1, CF_LONG, "arraySize"
AddFieldToStruct "PHSr4", 232, 1, CF_LONG, "preTrigger"
AddFieldToStruct "PHSr4", 236, 16, CF_TEXT, "unitsY"
AddFieldToStruct "PHSr4", 252, 16, CF_TEXT, "unitsX"
AddFieldToStruct "PHSr4", 268, 1, CF_FLOAT, "rangeMinX"
AddFieldToStruct "PHSr4", 272, 1, CF_FLOAT, "rangeMaxX"
AddFieldToStruct "PHSr4", 276, 1, CF_FLOAT, "plotMinY"
AddFieldToStruct "PHSr4", 280, 1, CF_FLOAT, "plotMaxY"
SealTaggedStruct "PHSr4", 284, 100

AddFieldToStruct "TrgCmp", 0, 32, CF_TEXT, "context"
AddFieldToStruct "TrgCmp", 32, 32, CF_TEXT, "server"
AddFieldToStruct "TrgCmp", 64, 64, CF_TEXT, "trigger"
AddFieldToStruct "TrgCmp", 128, 64, CF_TEXT, "description"
SealTaggedStruct "TrgCmp", 192, 64

AddFieldToStruct "TrgChn", 0, 32, CF_TEXT, "context"
AddFieldToStruct "TrgChn", 32, 32, CF_TEXT, "server"
AddFieldToStruct "TrgChn", 64, 64, CF_TEXT, "property"
AddFieldToStruct "TrgChn", 128, 64, CF_TEXT, "device"
SealTaggedStruct "TrgChn", 192, 64

AddFieldToStruct "TrgView", 0, 32, CF_TEXT, "context"
AddFieldToStruct "TrgView", 32, 64, CF_TEXT, "trigger"
AddFieldToStruct "TrgView", 96, 64, CF_TEXT, "desc"
AddFieldToStruct "TrgView", 160, 64, CF_TEXT, "file"
AddFieldToStruct "TrgView", 224, 1, CF_LONG, "reference"
AddFieldToStruct "TrgView", 228, 1, CF_LONG, "nComponents"
SealTaggedStruct "TrgView", 232, 64


End Sub


Function AppendDatabase(fname$, nsvrs%, nparam%) As Integer
' add a record
' is record name already there ? -> deactivate

End Function
Sub resetServer(ByVal context As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim rc As Integer
Dim dev As String

retryReset:
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dev = "/" + context + "/EVENTSTORE"
rc = T_EXECLINK(dev, "SRVRESET", dbout, vbNull, dbin, vbNull, CA_WRITE, 800)
If rc = link_not_open Or rc = connection_timeout Then
  If MsgBox("Could not reset server : " + RPCERROR(rc), vbAbortRetryIgnore) = vbRetry Then
    GoTo retryReset
  End If
  Exit Sub
End If

End Sub


