Imports System.Windows.Forms

Public Class slicesEditor

  Private initialSlice As String
  Public initialType As String
  Private initialIndex As Integer
  Private initialProcs As List(Of String)
  Private initialNumProcs As Integer
  Public initialProfileIndex As Integer
  Public initialConfigIndex As Integer
  Public initialColor As Color
  Private procListChanged As Boolean
  Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
    Dim colorString As String
    Dim procString As String
    Dim i As Integer, n As Integer, rc As Integer
    Dim isNew As Boolean
    If sliceBox.Text <> initialSlice Then
      If initialSlice.Contains("deleted") Then
        OpHist.configs(initialConfigIndex).prfList(initialProfileIndex).name = OpHist.GetFilledCharArray(sliceBox.Text, 64) 'sliceBox.Text.ToCharArray
        OpHist.ProfileList.Items.Item(i) = sliceBox.Text.ToCharArray
      Else
        isNew = True
      End If
    End If
    If isNew Then
      ' new slice
      If OpHist.configs(initialConfigIndex).prfList Is Nothing Then
        n = 0
      Else
        n = UBound(OpHist.configs(initialConfigIndex).prfList) + 1
      End If
      For i = 0 To n - 1
        If New String(OpHist.configs(initialConfigIndex).prfList(i).name) = sliceBox.Text Then
          GoTo OverAndOut
        End If
      Next
      OpHist.configs(initialConfigIndex).prfEdited = True
      colorString = Str(colorLabel.BackColor.R) + "," + Str(colorLabel.BackColor.G) + "," + Str(colorLabel.BackColor.B)
      Dim prf As OpHist.PrfCfg
      prf = New OpHist.PrfCfg
      prf.name = OpHist.GetFilledCharArray(sliceBox.Text, 64) 'sliceBox.Text.ToCharArray
      prf.type = OpHist.GetFilledCharArray(typeCombo.Text, 16) 'typeCombo.Text.ToCharArray
      prf.color = OpHist.GetFilledCharArray(colorString, 16) 'colorString.ToCharArray
      OpHist.colorLabel.BackColor = colorLabel.BackColor
      procString = ""
      For i = 0 To procList.Items.Count - 1
        If i > 0 Then procString = procString + ","
        procString = procString + procList.Items.Item(i)
        OpHist.SliceList.Items.Add(New String(procList.Items.Item(i)))
      Next
      prf.states = OpHist.GetFilledCharArray(procString, 512) 'procString.ToCharArray
      ReDim Preserve OpHist.configs(initialConfigIndex).prfList(n)
      OpHist.configs(initialConfigIndex).prfList(n) = prf
      OpHist.configs(initialConfigIndex).prfListSize = n + 1
      OpHist.ProfileList.Items.Add(New String(prf.name))
      OpHist.configs(initialConfigIndex).prfEdited = True
    Else
      If typeCombo.Text <> initialType Then
        OpHist.configs(initialConfigIndex).prfEdited = True
        OpHist.configs(initialConfigIndex).prfList(initialProfileIndex).type = OpHist.GetFilledCharArray(typeCombo.Text, 16) 'typeCombo.Text.ToCharArray
      End If
      If colorLabel.BackColor <> initialColor Then
        OpHist.configs(initialConfigIndex).prfEdited = True
        colorString = Str(colorLabel.BackColor.R) + "," + Str(colorLabel.BackColor.G) + "," + Str(colorLabel.BackColor.B)
        OpHist.configs(initialConfigIndex).prfList(initialProfileIndex).color = OpHist.GetFilledCharArray(colorString, 16) 'colorString.ToCharArray
        OpHist.colorLabel.BackColor = colorLabel.BackColor
      End If
      If removeStateBox.Checked Then
        Dim s As String
        OpHist.configs(initialConfigIndex).prfEdited = True
        OpHist.configs(initialConfigIndex).prfList(initialProfileIndex).type = "deleted".ToCharArray
        i = OpHist.ProfileList.FindStringExact(sliceBox.Text)
        If i >= 0 Then
          s = OpHist.GetTrimmedString(OpHist.ProfileList.Items.Item(i))
          OpHist.ProfileList.Items.Item(i) = s + "(deleted)"
        End If
      End If
      If procListChanged Then
        OpHist.configs(initialConfigIndex).prfEdited = True
        procString = ""
        For i = 0 To procList.Items.Count - 1
          If i > 0 Then procString = procString + ","
          procString = procString + OpHist.GetTrimmedString(procList.Items.Item(i))
        Next
        OpHist.configs(initialConfigIndex).prfList(initialProfileIndex).states = OpHist.GetFilledCharArray(procString, 512) 'procString.ToCharArray
      End If
    End If
OverAndOut:
    Me.DialogResult = System.Windows.Forms.DialogResult.OK
    Me.Close()
  End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

  Private Sub slicesEditor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim i As Integer

    typeCombo.Items.Add("slice")
    typeCombo.Items.Add("beam")
    typeCombo.Items.Add("error")

    i = typeCombo.FindStringExact(initialType)
    If i >= 0 Then typeCombo.SelectedIndex = i

    initialSlice = sliceBox.Text

    initialNumProcs = procList.Items.Count
    initialProcs = New List(Of String)
    For i = 0 To initialNumProcs - 1
      initialProcs.Add(procList.Items.Item(i))
    Next
    Dim idx As Integer
    If initialNumProcs > 0 Then idx = procCombo.FindStringExact(procList.Items.Item(0))
    procCombo.SelectedIndex = idx
    colorLabel.BackColor = initialColor
  End Sub

  Private Sub colorButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles colorButton.Click
    If ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
      colorLabel.BackColor = ColorDialog1.Color
    End If
  End Sub

  Private Sub procList_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles procList.DoubleClick
    If procList.SelectedIndex >= 0 Then
      procList.Items.RemoveAt(procList.SelectedIndex)
      procListChanged = True
    End If
  End Sub

  Private Sub addProcButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles addProcButton.Click
    If Len(procCombo.Text) > 0 And Not procList.Items.Contains(procCombo.Text) Then
      procList.Items.Add(procCombo.Text)
      procListChanged = True
    End If
  End Sub

  Private Sub typeCombo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles typeCombo.SelectedIndexChanged

  End Sub
End Class
