Imports System.Windows.Forms

Public Class statesEditor
  Private initialState As String
  Private initialDesc As String
  Private initialIndex As Integer
  Private initialProcs As List(Of String)
  Private initialNumProcs As Integer
  Public stateIndex As Integer
  Private Function makeValidName(ByVal name As String)
    makeValidName = name.Replace(" ", "_")
  End Function
  Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
    If triggerBox.Text <> initialState Then
      stateIndex = -1
      Dim s As State
      s = New State()
      triggerBox.Text = makeValidName(triggerBox.Text)
      s.name = triggerBox.Text
      s.tag = descriptionBox.Text
      s.machine = 1
      s.isEdited = True
      OpHist.addNewState(s)
      initialProcs.Clear() 'then all of the procs must appear as new 
    Else
      If descriptionBox.Text <> initialDesc Then
        OpHist.states(stateIndex).isEdited = True
        OpHist.states(stateIndex).tag = descriptionBox.Text
      End If
      If removeStateBox.Checked Then
        OpHist.states(stateIndex).isEdited = True
        OpHist.states(stateIndex).isRemoved = True
      End If
    End If
    Dim p As Proc
    Dim i As Integer, idx As Integer
    For i = 0 To procList.Items.Count - 1
      If initialProcs.Contains(procList.Items.Item(i)) Then
        'was found -> remove it for end comparison of lists
        initialProcs.Remove(procList.Items.Item(i))
      Else
        idx = OpHist.ProcList.FindStringExact(procList.Items.Item(i))
        If idx >= 0 Then
          'added old proc
          'If OpHist.procs(idx).states.Contains(triggerBox.Text) Then
          OpHist.procs(idx).isEdited = True
          OpHist.procs(idx).states.Add(triggerBox.Text)
          OpHist.procs(idx).nstates = OpHist.procs(idx).nstates + 1
          'End If
        Else
        'added brand new proc (not found in procCombo)
        p = New Proc()
        p.name = procList.Items.Item(i)
        p.nstates = 1
        p.states = New List(Of String)
        p.states.Add(triggerBox.Text)
        p.machine = 1
        p.isEdited = True
        OpHist.addNewProc(p)
      End If
      End If
    Next
    If initialProcs.Count > 0 Then
      'removed old proc (current count < initial)
      For i = 0 To initialProcs.Count - 1
        idx = OpHist.ProcList.FindStringExact(initialProcs(i))
        If idx >= 0 Then
          If OpHist.procs(idx).states.Contains(triggerBox.Text) Then
            OpHist.procs(idx).isEdited = True
            OpHist.procs(idx).states.Remove(triggerBox.Text)
            OpHist.procs(idx).nstates = OpHist.procs(idx).nstates - 1
          End If
        End If
      Next
    End If
    Me.DialogResult = System.Windows.Forms.DialogResult.OK
    Me.Close()
  End Sub

  Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
    Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
    Me.Close()
  End Sub

  Private Sub statesEditor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim i As Integer
    initialState = triggerBox.Text
    initialDesc = descriptionBox.Text
    initialIndex = stateIndex
    initialNumProcs = procList.Items.Count
    initialProcs = New List(Of String)
    For i = 0 To initialNumProcs - 1
      initialProcs.Add(procList.Items.Item(i))
    Next
  End Sub

  Private Sub procList_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles procList.MouseDoubleClick
    If procList.SelectedIndex >= 0 Then
      procList.Items.RemoveAt(procList.SelectedIndex)
    End If
  End Sub

  Private Sub addProcButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles addProcButton.Click
    If Len(procCombo.Text) > 0 And Not procList.Items.Contains(procCombo.Text) Then
      Dim p As String
      p = procCombo.Text
      If Not p.StartsWith("P") Then p = "P" + p
      procList.Items.Add(makeValidName(p))
    End If
  End Sub
End Class
