Attribute VB_Name = "tine"
'/** \file tine.bas
' *  \brief TINE Client and Server API Calls for Visual Basic
' *
' */
'        Global constants of general use
'        Version 18.04.01,swh:  fill in struct types

Global Const CF_DOUBLE = 512
Global Const CF_INTEGER = 513
Global Const CF_SHORT = 513
Global Const CF_INT16 = 513
Global Const CF_BYTE = 514
Global Const CF_INT8 = 514
Global Const CF_LONG = 515
Global Const CF_INT32 = 515
Global Const CF_TEXT = 516
Global Const CF_FLOAT = 517
Global Const CF_DLONG = 518
Global Const CF_INT64 = 518
Global Const CF_STRUCT = 519
Global Const CF_CHAR8 = 520
Global Const CF_STRING8 = 520
Global Const CF_NAME8 = 520
Global Const CF_CHAR16 = 521
Global Const CF_STRING16 = 521
Global Const CF_NAME16 = 521
Global Const CF_CHAR16FI = 522
Global Const CF_NAME16FI = 522
Global Const CF_BIT = 523
Global Const CF_HITTS = 524
Global Const CF_CHAR32 = 525
Global Const CF_STRING32 = 525
Global Const CF_NAME32 = 525
Global Const CF_FI = 526
Global Const CF_FLTINT = 526
Global Const CF_II = 527
Global Const CF_LI = 527
Global Const CF_LL = 527
Global Const CF_INTINT = 527
Global Const CF_LNGINT = 527
Global Const CF_DI = 528
Global Const CF_DBLINT = 528
Global Const CF_SI = 529
Global Const CF_SHTINT = 529
Global Const CF_TDS = 530
Global Const CF_IFI = 530
Global Const CF_CHAR48 = 531
Global Const CF_NAME48 = 531
Global Const CF_STRING48 = 531
Global Const CF_CHAR8I = 532
Global Const CF_NAME8I = 532
Global Const CF_CHAR16I = 533
Global Const CF_NAME16I = 533
Global Const CF_CHAR32I = 534
Global Const CF_NAME32I = 534
Global Const CF_CHAR48I = 535
Global Const CF_NAME48I = 535

Global Const CF_USTRING = 536
Global Const CF_XYS = 537
Global Const CF_FFI = 537
Global Const CF_FLTFLTINT = 537
Global Const CF_FLTINTINT = 538
Global Const CF_FILTER = 539
Global Const CF_IFFF = 539
Global Const CF_INTFLTFLTFLT = 539
Global Const CF_SPECTRUM = 540

Global Const CF_ADDRESS = 541
Global Const CF_IIII = 541
Global Const CF_INTINTINTINT = 541
Global Const CF_WINDOW = 542
Global Const CF_TTII = 542
Global Const CF_POINT = 543
Global Const CF_FF = 543
Global Const CF_XY = 543
Global Const CF_FLTFLT = 543
Global Const CF_TDSI = 544
Global Const CF_INTFLTSHTSHT = 544
Global Const CF_BOOLEAN = 545
Global Const CF_IIFF = 546
Global Const CF_INTINTFLTFLT = 546
Global Const CF_FIFI = 547
Global Const CF_FLTINTFLTINT = 547
Global Const CF_NAME64 = 548
Global Const CF_CHAR64 = 548
Global Const CF_STRING64 = 548
Global Const CF_NAME64I = 549
Global Const CF_CHAR64I = 549
Global Const CF_STRING64I = 549
Global Const CF_INTDBL = 550
Global Const CF_LNGDBL = 550
Global Const CF_FLTDBL = 551
Global Const CF_DBLDBL = 552
Global Const CF_NAMEDBLDBL = 553
Global Const CF_NAME16DBLDBL = 553
Global Const CF_NAME16INTINT = 554
Global Const CF_CHAR16INTINT = 554
Global Const CF_NAME16II = 554
Global Const CF_INTINTINT = 555
Global Const CF_III = 555
Global Const CF_NAME32DBLDBL = 556
Global Const CF_CHAR32DBLDBL = 556
Global Const CF_STRING32DBLDBL = 556
Global Const CF_NAME64DBLDBL = 557
Global Const CF_CHAR64DBLDBL = 557
Global Const CF_STRING64DBLDBL = 557
Global Const CF_UNAME = 558
Global Const CF_XML = 559
Global Const CF_DBLDBLDBL = 560
Global Const CF_NAME64DBLDBLDBL = 561
Global Const CF_CHAR64DBLDBLDBL = 561
Global Const CF_STRING64DBLDBLDBL = 561
Global Const CF_BITFIELD8 = 562
Global Const CF_BITFIELD16 = 563
Global Const CF_BITFIELD32 = 564
Global Const CF_BITFIELD64 = 565
Global Const CF_NAME64DBL = 566
Global Const CF_IMAGE = 567

Global Const CF_DEFAULT = 766
Global Const CF_NULL = 767

Global Const CM_CANCEL = 0
Global Const CM_SINGLE = 1
Global Const CM_REFRESH = 2
Global Const CM_DATACHANGE = 2
Global Const CM_POLL = 3
Global Const CM_TIMER = 3
Global Const CM_REGISTER = 4
Global Const CM_BCAST = &H100
Global Const CM_MCAST = &H200
Global Const CM_NETWORK = &H200
Global Const CM_USE_ON_ERROR = &H400
Global Const CM_GROUPED = &H1000
Global Const CM_CONNECT = &H2000
Global Const CM_WAIT = &H4000
Global Const CM_SYNCNOTIFY = &H8000

Global Const ACCESS_LOCK_UNLOCKED = 0
Global Const ACCESS_LOCK_PREEMPTIVE = 1
Global Const ACCESS_LOCK_PERSISTENT = 2
Global Const ACCESS_LOCK_ABORT = 3

Enum AccessLockTypes
  AccessUnlocked = ACCESS_LOCK_UNLOCKED
  AccessPreemptive = ACCESS_LOCK_PREEMPTIVE
  AccessPersistent = ACCESS_LOCK_PERSISTENT
  AccessAbort = ACCESS_LOCK_ABORT
End Enum

Type FLTINT
 fval As Single
 iVal As Long
End Type

Type FLTDBL
 fval As Single
 dval As Double
End Type

Type INTINT
 i1val As Long
 i2Val As Long
End Type

Type SHTI
 sval As Integer
 iVal As Long
End Type

Type LNGINT
 lval As Long
 iVal As Long
End Type

Type INTDBL
 iVal As Long
 dval As Double
End Type

Type DBLINT
 dval As Double
 iVal As Long
End Type

Type DBLDBL
 d1val As Double
 d2Val As Double
End Type

Type FLTFLT
  f1val As Single
  f2val As Single
End Type

Type FLTFLTINT
  f1val As Single
  f2val As Single
  iVal As Long
End Type

Type FLTINTINT
  fval As Single
  i1val As Long
  i2Val As Long
End Type

Type INTINTINT
  i1val As Long
  i2Val As Long
  i3val As Long
End Type

Type INTINTINTINT
  i1val As Long
  i2Val As Long
  i3val As Long
  i4val As Long
End Type

Type INTFLTFLTFLT
  iVal As Long
  f1val As Single
  f2val As Single
  f3val As Single
End Type

Type INTINTFLTFLT
 i1val As Long
 i2Val As Long
 f1val As Single
 f2val As Single
End Type

Type FLTINTFLTINT
 f1val As Single
 i1val As Long
 f2val As Single
 i2Val As Long
End Type

Type NAME8
  nam(7) As Byte
End Type

Type NAME16
  nam(15) As Byte
End Type

Type NAME16I
  nam(15) As Byte
  iVal As Long
End Type

Type NAME32
  nam(31) As Byte
End Type

Type NAME48
  nam(47) As Byte
End Type

Type NAME64
  nam(63) As Byte
End Type

Type NAME32I
  nam(31) As Byte
  iVal As Long
End Type

Type NAME48I
  nam(47) As Byte
  iVal As Long
End Type

Type NAME64I
  nam(63) As Byte
  iVal As Long
End Type

Type NAMEFI
  nam(15) As Byte
  fval As Single
  iVal As Long
End Type

Type NAME16FI
  nam(15) As Byte
  fval As Single
  iVal As Long
End Type

Type NAME16II
  nam(15) As Byte
  i1val As Long
  i2Val As Long
End Type

Type CHAR16FI
  nam(15) As Byte
  f As Single
  i As Long
End Type

Type NAME32DBLDBL
  nam(31) As Byte
  d1val As Double
  d2Val As Double
End Type

Type NAME64DBLDBL
  nam(63) As Byte
  d1val As Double
  d2Val As Double
End Type

Type NAME64DBL
  nam(63) As Byte
  dval As Double
End Type

Type FSTRUCT
  date As Integer
  time As Integer
  fname(7) As Byte
End Type

Type TDS
  tval As Long
  dval As Single
  sval As Long
End Type

Type INTFLTINT
  i1val As Long
  fval As Single
  i2Val As Long
End Type

Type USTRING
  iVal As Long
  f1val As Single
  f2val As Single
  ts As Long
  STR(79) As Byte
End Type

Type UNAME
  iVal As Long
  f1val As Single
  f2val As Single
  f3val As Single
  nam(15) As Byte
End Type

Type DSPECTRUM
  STR(79) As Byte
  ts As Long
  Start As Single
  inc As Single
  Status As Long
  spectrum(4095) As Single
End Type

Declare Function SetAcopQueueDepth Lib "acop.ocx" (ByVal queueDepth%) As Integer

'
' | converts Byte array to UNICODE string and vice versa |

Type TM
  tm_sec As Long   '0 - 59
  tm_min As Long   '0 - 59
  tm_hour As Long  '0 - 23
  tm_mday As Long  'day of month (1 - 31)
  tm_mon As Long   'use 1 = Jan., 12 = Dec.
  tm_year As Long  'either 1998 or 98 will work
  tm_wday As Long  ' not used
  tm_yday As Long  ' not used
  tm_isdst As Long ' not used
End Type

Declare Sub Bytes2String Lib "utils32.dll" (ByVal s$, byteArray As Byte, ByVal numBytes%)
Declare Sub String2Bytes Lib "utils32.dll" (byteArray As Byte, ByVal s$, ByVal numBytes%)
Declare Function MKTIME Lib "utils32.dll" (t As TM) As Long
Declare Function UNIXTIME Lib "utils32.dll" () As Long
Declare Sub LCLTIME Lib "utils32.dll" (ByVal t As Long, st As TM)

'
'         network routines for data acquisition

Type rpctext
  text As String * 80
End Type
Dim netuser As String * 16

'/**
' * \struct DBLK
' * \brief DBLK defines a TINE data object for Visual Basic calls
' *
' * - dArrayLength is the size of the data set in terms of the format size specified.
' * - dFormat is the TINE format of the data set
' * - dTag is an optional data tag used typically to identify user-defined structures
' * Note that this is held as a byte array (in order to avoid problems with embedded
' * unicode versus ascii.  This means that the translation routines BSTR() (returns a
' * string from a byte array) and BARR() (makes a byte array from a string) should be
' * used when working directly with this field.
' *
' * DBLK is used in certain calls where the data arrays are to be passed by reference
' * as a separate parameter in the calling routine
' *
' * \see T_EXECLINK(), T_OPENLINK(), DTYPE
' */
Type DBLK
  dArrayLength As Long
  dFormat As Integer
  reserved As Integer
  dTag(7) As Byte
End Type

'/**
' * \struct DTYPE
' * \brief DTYPE defines a TINE data object
' *
' * - dArrayLength is the size of the data set in terms of the format size specified.
' * - dFormat is the TINE format of the data set.
' * - dTag is an optional data tag used typically to identify user-defined structures.
' * Note that this is held as a byte array (in order to avoid problems with embedded
' * unicode versus ascii.  This means that the translation routines BSTR() (returns a
' * string from a byte array) and BARR() (makes a byte array from a string) should be
' * used when working directly with this field.
' * - ddata is a reference to the data set.  This need to be a pointer, so you will need
' * to apply the CADDR() routine to your Visual Basic array.
' *
' *
' * DTYPE is used in certain calls where the pointer address of the data array
' * is passed within this structure
' *
' * \see T_ATTACHLINK(), DBLK
' */
' Release 4.0 DTYPE structure:
Type DTYPE
  dArrayLength As Long
  dFormat As Integer
  xferReason As Integer
  dStamp As Long
  sysStamp As Long
  dTimeStamp As Double
  dTag(15) As Byte
  ddata As Long
End Type

Declare Function RPCAssignBufferSpace Lib "tinecln32.dll" (ByVal rcvBufferSizeInBytes As Long) As Integer
Declare Function RPCSynchronousNotification Lib "tinecln32.dll" (ByVal useSynchronousNotification As Long) As Integer
Declare Sub SetClientCycleIdle Lib "tinecln32.dll" (ByVal isIdle As Long)

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''    Direct inteface routines: (But use ACOP if you can)  ''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'/**
' * \brief executes a synchronous link
' *
' * Synchronous data exchange. T_EXECLINK() does not complete until the data transfer has completed or
' * a timeout has ensued.
' *
' * \param devName is the full device name (/\<Context\>/\<Server\>/\<Device\>) of the device to contact.
' * For example: "/HERA/BPM/WL167".
' * \param devProperty is the device property requested, for example "ORBIT.X"
' * \param dout is a reference to the output data block, that is, the data set to be returned from the server
' * to the client. The associated data are returned in the 'dataout' parameter.
' * \param dataout is a reference to the data array or variable to receive the returned data.  If no data are
' * requested in the call, then a '0' should be passed, and the dArraySize field in 'dout' should be set to '0'.
' * \param din is a reference to the input data block, that is, the data set to be sent to the server from the
' * client. The associated data to be sent should be contained in the 'datain' parameter.
' * \param dindata is a reference to the data array or variable to be sent.  If no data are to be sent
' * in the call, then a '0' should be passed, and the dArraySize field in 'din' should be set to '0'.
' * \param devAccess is the data access mode.  A client can set either CA_READ and/or CA_WRITE access.
' * \param devTimeout is the allowed timeout in milliseconds for the call to complete
' *
' * \see DBLK
' *
' */
Declare Function T_EXECLINK Lib "tinecln32.dll" (ByVal DevName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, dataIn As Any, ByVal devAccess As Integer, ByVal devTimeout As Long) As Integer
Declare Function T_OPENLINK Lib "tinecln32.dll" (ByVal hWnd As Long, ByVal DevName As String, ByVal DevProp As String, dout As DBLK, din As DBLK, dataIn As Any, ByVal acc As Integer, ByVal timer As Long, ByVal mode As Integer) As Integer
Declare Function EXECLINKEx Lib "tinecln32.dll" (ByVal DevName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, dataIn As Any, ByVal devAccess As Integer, ByVal devTimeout As Long) As Integer
Declare Function EXECLINK Lib "tinecln32.dll" (ByVal DevName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, dataIn As Any, ByVal devAccess As Integer) As Integer

'/**
' * \brief established an asynchronous link
' *
' * Synchronous data exchange. T_ATTACHLINK() will establish a data link to the designated
' * server if possible and return a positive link handle if successful.  When data are
' * tranfered over the link, the designated callback routine will be called.
' *
' * \param devName is the full device name (/\<Context\>/\<Server\>/\<Device\>) of the device to contact.
' * For example: "/HERA/BPM/WL167".
' * \param devProperty is the device property requested, for example "ORBIT.X"
' * \param dout is a reference to the output DTYPE object, that is, the data set to be returned from the server
' * to the client. The associated data are returned in array referenced by the ddata field.
' * \param din is a reference to the input DTYPE object, that is, the data set to be sent to the server from the
' * client. The associated data to be sent should be referenced by the ddata field.
' * \param devAccess is the data access mode.  A client can set either CA_READ and/or CA_WRITE access.
' * \param timer is the polling rate in milliseconds to be registered with the server.
' * \param callback is the callback routine to be called when new data arrive
' * \param accessMode is the data access mode: one of CM_SINGLE (once), CM_REFRESH (on change),
' * CM_POLL (on timer) in combination with any access mode flags (e.g. CM_CONNECT, CM_NETWORK, etc.)
' *
' * \note In assigning references to a DTYPE object, you will have to use the CADDR() to retreive
' * the reference to the Visual Basic array.  In passing a callback routine, you will have to
' * use the AddressOf function on a Visual Basic Sub which can only be found within a .bas Module.
' * Also note that it is very difficult to debug a callback routine.  Do NOT put a break point
' * inside this Sub in design mode, as Visual Basic will hang!
' *
' *
' * \see DTYPE, CADDR()
' *
' */
Declare Function T_ATTACHLINK Lib "tinecln32.dll" ( _
  ByVal DevName As String, ByVal devProperty As String, dout As DTYPE, din As DTYPE, _
  ByVal devAccess As Integer, ByVal timer As Long, ByVal callback As Long, ByVal AccessMode As Integer _
  ) As Integer

Declare Function T_CLOSELINK Lib "tinecln32.dll" (ByVal ID%) As Integer

Declare Sub T_setSupressHeartbeatNotification Lib "tinecln32.dll" (ByVal supressNotification As Long)

Declare Function GetArchivedDataAsFloat Lib "tinecln32.dll" (ByVal devsrv As String, ByVal starttime As Long, ByVal stoptime As Long, fiDataArray As FLTINT, num As Long) As Integer
Declare Function GetArchivedDataAsText Lib "tinecln32.dll" (ByVal devsrv As String, ByVal starttime As Long, ByVal stoptime As Long, niDataArray As NAME32I, num As Long) As Integer
Declare Function GetArchivedDataAsSnapshot Lib "tinecln32.dll" (ByVal devsrv As String, targetTime As Long, fDataArray As Single, ByVal siz As Long) As Integer

'
' Legacy routines:
'Define Arguments in function call RPC (13.08.97)
'Eqm$ "EQPNAME" (points to REC and Server Task) [ now max of 16 characters ]
'Eqno% Equipment number (if server supports multiple devices)
'prop$ "PROPERTY"  VB string with up to 32 characters (now)
'num%  (number of data requested (ie array dimension for dat) SIGN, next line !!
'For READ, num%>0  , for WRITE, num% = -1*(array dimension) !!!!
'dat   (user defined array for data transfer - must be big enough !!)
'datasize (size of data transfer array in bytes ( for VB, use len(dat) )
'format  ( pktr datatype - CF_SHORT, CF_LONG, etc, see definitions above)
Declare Function rpc Lib "tinecln32.dll" Alias "RPC" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%) As Integer
Declare Function RPCEx Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%, ByVal Timeout&) As Integer
Declare Function HOTRPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%) As Integer
Declare Function CLOSERPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal ID%) As Integer
Declare Function GETRPC Lib "tinecln32.dll" (ByVal ID%, dat As Any) As Integer
Declare Function GETRPCSTR Lib "tinecln32.dll" Alias "GETRPC" (ByVal ID%, ByVal sdat As String) As Integer
Declare Function PUTRPC Lib "tinecln32.dll" (ByVal ID%, dat As Any) As Integer
Declare Function PUTRPCSTR Lib "tinecln32.dll" Alias "PUTRPC" (ByVal ID%, ByVal sdat As String) As Integer
Declare Function GETRPCDATA Lib "tinecln32.dll" (ByVal ID%, dat As Any, ts&) As Integer
Declare Function GETRPCSTRDATA Lib "tinecln32.dll" Alias "GETRPCDATA" (ByVal ID%, ByVal sdat As String, ts&) As Integer
Declare Function RPCERR Lib "tinecln32.dll" (ByVal errno%, ByVal errstr$) As Integer
Declare Function GetRPCLastError Lib "tinecln32.dll" (ByVal cc%, ByVal errstr$) As Integer
Declare Function GETGLOBAL Lib "tinecln32.dll" (ByVal Keyword$, dat As Any, ByVal size%, ByVal fmt%) As Integer
Declare Function GETUSER Lib "tinecln32.dll" (ByVal user$) As Integer
Declare Function SUBSCRIBE Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%, ByVal mode%) As Integer
Declare Function A_RPC Lib "tinecln32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function SA_RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%) As Integer
Declare Function S_RPC Lib "tinecln32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal DataSize%, ByVal fmt%) As Integer

Declare Function AcquireAndRegisterStruct Lib "tinecln32.dll" (ByVal DevName$, ByVal structTag$, ByVal number&) As Integer
Declare Function GetStructFromTag Lib "tinecln32.dll" (ByVal structTag$, ByVal key$, structFmt As NAME64DBLDBL, ByVal arraySiz&) As Integer
Declare Function AddFieldToStruct Lib "tinecln32.dll" Alias "AddFieldToStructA" (ByVal structTag$, ByVal addr&, ByVal size&, ByVal fmt&, ByVal field$) As Integer
Declare Function SealTaggedStruct Lib "tinecln32.dll" Alias "SealTaggedStructA" (ByVal structTag$, ByVal structSize&, ByVal maxArraySize&) As Integer
Declare Function OpenBitField Lib "tinecln32.dll" Alias "openBitFieldA" (ByVal eqm$, ByVal tag$, ByVal fmt As Long) As Integer
Declare Function AddFieldToBitField Lib "tinecln32.dll" Alias "AddFieldToBitFieldA" (ByVal eqm$, ByVal tag$, ByVal Mask As Long, ByVal field$) As Long
Declare Function FILLSTRUCT Lib "tinecln32.dll" (ByVal structTag$, ByVal structSize%, ByVal maxArraySize%, ByVal fmt%) As Integer
Declare Function GETSTRUCTSIZE Lib "tinecln32.dll" (ByVal structTag$) As Long
Declare Function RPCGETLASTERR Lib "tinecln32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTERROR Lib "tinecln32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTSOURCE Lib "tinecln32.dll" (ByVal srcstr$) As Integer
Declare Function RPCGETLASTTIME Lib "tinecln32.dll" () As Long
Declare Function T_GETDATATIMESTAMP Lib "tinecln32.dll" () As Double
Declare Function T_GETCONTEXTS Lib "tinecln32.dll" (contexts As NAME16, ncontexts As Long) As Integer
Declare Function T_GETDEVICESERVERS Lib "tinecln32.dll" (context As NAME16, servers As NAME16, nservers As Long) As Integer
Declare Function T_GETCONTEXTSFromFile Lib "tinecln32.dll" (contexts As NAME16, ncontexts As Long) As Integer
Declare Function T_GETDEVICESERVERSFromFile Lib "tinecln32.dll" (context As NAME16, servers As NAME16, nservers As Long) As Integer
Declare Function T_GETDEVICENAMES Lib "tinecln32.dll" (context As NAME16, servers As NAME16, names As NAME16, property As NAME32, ndevices As Long) As Integer
Declare Function T_GETDEVICEPROPERTIES Lib "tinecln32.dll" (context As NAME16, servers As NAME16, name As NAME16, Properties As NAME32, nproperties As Long) As Integer
Declare Function T_PUTRPCERRORVALUE Lib "tinecln32.dll" (ByVal LinkIndex As Integer, errValue As Any) As Integer
Declare Function GETRPCFECDATA Lib "tinecln32.dll" (ByVal context$, ByVal server$, ByVal eqm$, ByVal fec$, alarmSystem%, _
                 ByVal ipxnet$, ByVal ipxAddr$, ByVal ipaddr$, portOffset%) As Integer
Declare Function GETFECDATA Lib "tinecln32.dll" (ByVal FecName As String, ipxAddr As Byte, macAddr As Byte, ByVal ipaddr As String, portOffset As Integer) As Integer
Declare Function vBalsnExecLink Lib "tinecln32.dll" (ByVal DevName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, dataIn As Any, ByVal devAccess As Integer, ByVal devTimeout As Long) As Integer
Declare Function vBalsnExecLinkEx Lib "tinecln32.dll" (ByVal DevName As String, ByVal devProperty As String, dout As DBLK, dataout As Any, din As DBLK, dataIn As Any, ByVal devAccess As Integer, ByVal devTimeout As Long, dataTimeStamp As Double) As Integer
Declare Function tgetArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, ByVal datafmt As Integer, dataout As Any, ByVal buffersiz As Long) As Integer
Declare Function tgetSingleArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Single, ByVal buffersiz As Long) As Integer
Declare Function tgetDoubleArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Double, ByVal buffersiz As Long) As Integer
Declare Function tgetLongArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Long, ByVal buffersiz As Long) As Integer
Declare Function tgetShortArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, dataout As Integer, ByVal buffersiz As Long) As Integer
Declare Function tgetStringArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, ByVal dataout As String, ByVal buffersiz As Long) As Integer
Declare Function tgetString Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, ByVal dataout As String, ByVal buffersiz As Long) As Integer
Declare Function GetElemSource Lib "tinecln32.dll" (ByVal devcontext As String, ByVal devServer As String, ByVal DevName As String, ByVal devProperty As String, _
                 ByVal FecName As String, ByVal eqmName As String, ByVal rmtServer As String, ByVal rmtProperty As String) As Integer
Declare Function tputgetArrayEx Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, ByVal access As Integer, ByVal putdatafmt As Integer, _
                 putdata As Any, ByVal putsiz As Long, ByVal getdatafmt As Integer, getdata As Any, ByVal getsiz As Long, dTimeStamp As Double)
Declare Function tputShortArray Lib "tinecln32.dll" (ByVal fullDeviceNameAndProperty As String, putdata As Integer, ByVal putsize As Long) As Integer

Declare Function GetSystemContexts Lib "tinecln32.dll" Alias "GetSystemContextsA" (contexts As NAME32, ncontexts As Long) As Integer
Declare Function GetSystemServers Lib "tinecln32.dll" Alias "GetSystemServersA" (ByVal context As String, servers As NAME32, nservers As Long) As Integer
Declare Function GetSystemProperties Lib "tinecln32.dll" Alias "GetSystemPropertiesA" (ByVal server As String, Properties As NAME64, nproperties As Long) As Integer
Declare Function GetSystemDevices Lib "tinecln32.dll" Alias "GetSystemDevicesA" (ByVal server As String, ByVal property As String, devices As NAME64, ndevices As Long) As Integer

Type MessageLog
  ts As Long
  Status As Long
  msg(127) As Byte
End Type
Declare Function GetMessages Lib "tinecln32.dll" (ml As MessageLog, num As Long) As Integer
Declare Sub ClearMessages Lib "tinecln32.dll" ()

Declare Function GetEqpStatisticsCounters Lib "tinecln32.dll" (stbuf As Long)

Type ElemQueryStruct
  devServ(15) As Byte
  eqm(7) As Byte
  DevProp(31) As Byte
  DevName(15) As Byte
  formatIn As Integer
  formatOut As Integer
  devcontext(15) As Byte
'  strTagIn(7) As Byte
'  strTagOut(7) As Byte
  sizeIn As Long
  sizeOut As Long
  access As Integer
  CompCode As Integer
  pollRate As Integer
  FecIndex As Integer
  links(19) As Integer
  timeoutCount As Integer
  lockCount As Integer
  ID As Integer
  heartbeat As Integer
  mode As Integer
  PrimeMode As Integer
  RPCprotocol As Integer
  protocol As Integer
  time As Long
  starttime As Long
  RPCtimestamp As Long
  counter As Long
End Type
Declare Function GETELEMDATA Lib "tinecln32.dll" (elem As ElemQueryStruct, ByVal num%) As Integer
Declare Function RPCDBG Lib "tinecln32.dll" (ByVal dbg%) As Integer
Declare Sub FlushCache Lib "tinecln32.dll" Alias "FLUSHCACHE" ()
Declare Function SetUseLoopback Lib "tinecln32.dll" (ByVal loopbackValue As Integer) As Integer

Type RPCFECINFO
  os(11) As Byte
  Description(63) As Byte
  Location(31) As Byte
  hardware(31) As Byte
  subsystem(15) As Byte
  responsible(31) As Byte
End Type
Type RPCFECINFO_R4
  os(15) As Byte
  Description(63) As Byte
  Location(47) As Byte
  hardware(31) As Byte
  version(15) As Byte
  responsible(31) As Byte
End Type
Declare Function GETRPCFECINFO Lib "tinecln32.dll" (ByVal FecName$, rpcfec As RPCFECINFO) As Integer
Declare Function GetHostFromFecName Lib "tinecln32.dll" (ByVal FecName$, ByVal hostname$) As Integer
Declare Function getDataQueueDepth Lib "tinecln32.dll" () As Long
Declare Sub setDataQueueDepth Lib "tinecln32.dll" (ByVal queueDepth As Long)
Declare Sub SetConnectionTableCapacity Lib "tinecln32.dll" (ByVal capacity As Long)

' ancient history
Type PropertyQuery
  prpName(31) As Byte
  prpDesc(31) As Byte
  prpSize As Integer
  prpFormat As Byte
  prpAccess As Byte
End Type

'really old
Type PropertyQueryEx
  prpName(31) As Byte
  prpDesc(63) As Byte
  prpRedir(1) As NAME16
  prpTag(7) As Byte
  prpTagIn(7) As Byte
  prpUnits(15) As Byte
  prpMinValue As Single
  prpMaxValue As Single
  prpSize As Long
  prpSizeIn As Long
  prpNumOverloads As Long
  prpHistoryDepthShort As Integer
  prpHistoryDepthLong As Integer
  prpFormat As Byte
  prpFormatIn As Byte
  prpAccess As Byte
  prpGraphType As Byte
End Type

' legacy
Type XPropertyQuery
  prpName(31) As Byte
  prpDesc(63) As Byte
  prpRedir(1) As NAME16
  prpTag(7) As Byte
  prpTagIn(7) As Byte
  prpUnits(15) As Byte
  prpMinValue As Single
  prpMaxValue As Single
  prpSize As Long
  prpSizeIn As Long
  prpNumOverloads As Long
  prpHistoryDepthShort As Integer
  prpHistoryDepthLong As Integer
  prpFormat As Byte
  prpFormatIn As Byte
  prpAccess As Byte
  prpGraphType As Byte
  rangeUnits(15) As Byte
  rangeMinValue As Single
  rangeMaxValue As Single
  numRows As Integer
  RowSize As Integer
  prpArrayType As Integer
  reserved(2) As Integer
End Type

' modern
Type PrpQuery
  prpName(63) As Byte
  prpDsc(63) As Byte
  prpRdr(191) As Byte
  prpTag(15) As Byte
  prpTagIn(15) As Byte
  prpUnits(15) As Byte
  prpMinValue As Single
  prpMaxValue As Single
  prpSize As Long
  prpSizeIn As Long
  prpNumOverloads As Long
  prpHistoryDepthShort As Integer
  prpHistoryDepthLong As Integer
  prpFormat As Byte
  prpFormatIn As Byte
  prpAccess As Byte
  prpGraphType As Byte
  rangeUnits(15) As Byte
  rangeMinValue As Single
  rangeMaxValue As Single
  numRows As Integer
  RowSize As Integer
  prpArrayType As Integer
  reserved(2) As Integer
End Type

'
' Graphical type constants (prpGraphType parameter above)
'
Global Const GT_LIN = 0
Global Const GT_LOG = 1
Global Const GT_SLOG = 2
Global Const GT_TD = 3
Global Const GT_BIT = 4
Global Const GT_TEXT = 5
Global Const GT_ABS = 6
Global Const GT_HEX = 7


'
' array type constants
'
Global Const AT_UNKNOWN = &H0
Global Const AT_SCALAR = &H1
Global Const AT_SINGLE = &H2
Global Const AT_DOUBLE = &H4
Global Const AT_CHANNEL = &H10
Global Const AT_SPECTRUM = &H20
Global Const AT_TRACE = &H20
Global Const AT_WAVEFORM = &H20
Global Const AT_STRUCTURED = &H40
Global Const AT_COLLECTION = &H40
Global Const AT_UNSTRUCTURED = &H80
Global Const AT_BLOB = &H80
Global Const AT_IMAGE = &H80
Global Const AT_JPEG = &H100
Global Const AT_MPEG = &H200
Global Const AT_BMP = &H400
Global Const AT_GIF = &H800
Global Const AT_WAV = &H1000
Global Const AT_MP3 = &H2000

Global Const IFLG_LITTLE_ENDIAN = &H1
Global Const IFLG_LOSSLESS_COMP = &H2
Global Const IFLG_HORIZONTAL_FLIP = &H4
Global Const IFLG_VERTICAL_FLIP = &H8

Type TImageSourceHeader
   baseTag As Long 'base Id
   cameraPortId As Long 'specific id
   versionTag As Long 'version
   totalLength As Long 'total length in bytes (all headers + frame)
   timestampSeconds As Long 'image timestamp (UTC seconds)
   timestampMicroseconds As Long 'image timestamp (micro seconds)
   cameraPortName(63) As Byte
End Type

Type TImageFrameHeader
   sourceWidth As Long
   sourceHeight As Long
   aoiWidth As Long
   aoiHeight As Long
   XStart As Long
   yStart As Long
   bytesPerPixel As Long
   effectiveBitsPerPixel As Long
   horizontalBinning As Long
   verticalBinning As Long
   sourceFormat As Long
   imageFormat As Long
   frameNumber As Long 'unsigned
   eventNumber As Long 'unsigned
   xScale As Single
   yScale As Single
   imageRotation As Single
   fspare1 As Single
   fspare2 As Single
   fspare3 As Single
   imageFlags As Long
   ispare1 As Long
   ispare2 As Long
   ispare3 As Long
   appendedFrameSize As Long
End Type

Type hdrIMAGE
   sourceHeader As TImageSourceHeader
   frameHeader As TImageFrameHeader
End Type

Type DIMAGE
   sourceHeader As TImageSourceHeader
   frameHeader As TImageFrameHeader
   frameBufferSize As Long ' unsigned long
   frameBuffer As Long ' pointer to buffer
End Type

Type HRS
  prp(63) As Byte '/* property name of the record */
  dev(63) As Byte '/* device name of the record */
  datasiz As Long '/* call size of the record */
  datafmt As Long '/* calling format of the record */
  pollingRate As Long '/* polling rate in msec */
  archiveRate As Long '/* archive rate in msec */
  depthShort As Long '/* for short term storage */
  depthLong As Long '/* for long term storage */
  heartbeat As Long '/* archive heartbeat in sec */
  pTolerance As Single '/* percent tolerance */
  aTolerance As Single '/* absolute tolerance */
End Type

'
'              Special export from Acop.dll

Declare Function GetCompletionDataSize Lib "acop.dll" () As Long

'
'              Net Globals

Global HPENERGY As Integer   'Hera Proton energy
Global HPCURRENT As Double   'Hera Proton Beam Current
Global HPTAU     As Double   'Hera Proton Beam Lifetime
Global HEENERGY As Integer   'Hera Electron energy
Global HECURRENT As Double   'Hera Electron Beam Current
Global HETAU     As Double   'Hera Electron Beam Lifetime

' The associated get routines are:
'     HERAGetEnergy(typ$)
'     HERAGetCurrent(typ$)
'     HERAGetLifetime(typ$)
' where typ$ is either "PROTON" or "ELECTRON"
' the above varables are then updated
' e.g. To get the current HERA Proton magnet energy:
'    rc% = HERAGetEnergy("PROTON")
'    If rc% Then
'      MsgBox "RPC Error : " + RPCERROR(rc%)
'    Else
'      MsgBox "Then energy in HERA P is: " + str$(HPENERGY)
'    End If

'
'              Server Routines

Declare Function Address Lib "tinesrv32.dll" (r As Any) As Long
Declare Function CADDR Lib "tinesrv32.dll" (r As Any) As Long
Declare Function CSTRADDR Lib "tinesrv32.dll" Alias "CADDR" (ByVal r As String) As Long
Declare Function UTIME Lib "tinesrv32.dll" () As Long
Declare Function DebugServer Lib "tinesrv32.dll" (ByVal level%) As Integer
Declare Function SetMinimumPollingRate Lib "tinesrv32.dll" (ByVal mpr%) As Integer
Declare Function RegisterFecName Lib "tinesrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal Port%) As Integer
Declare Function RegisterFecNameEx Lib "tinesrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal Port%, ByVal context$) As Integer
Declare Function FILLSRVSTRUCT Lib "tinesrv32.dll" (ByVal tag$, ByVal addr%, ByVal size%, ByVal fmt%) As Integer
Declare Sub GetCallerInfo Lib "tinesrv32.dll" (ByVal ClientName$, ByVal ClientAddress$)
Declare Function SRVSTATUS Lib "tinesrv32.dll" () As Integer
Declare Function feclog Lib "tinesrv32.dll" (ByVal txt As String) As Integer
Declare Function ClsLog Lib "tinecln32.dll" (ByVal context As String, ByVal tag As String, ByVal logger As String, ByVal priority As Long, ByVal Status As Long, ByVal txt As String) As Integer
Declare Function appendLog Lib "tinesrv32.dll" (ByVal filename As String, ByVal procname As String, ByVal txt As String) As Integer
Declare Function SetWorkAreaSize Lib "tinesrv32.dll" (ByVal siz As Long) As Long
Declare Function setFecLogDepth Lib "tinesrv32.dll" (ByVal nlines As Integer) As Integer
Declare Function SetBurstLimit Lib "tinesrv32.dll" (ByVal npackets As Long) As Long
Declare Function PutCommandsInLogFile Lib "tinesrv32.dll" (ByVal flag As Long) As Integer
Declare Function SetCycleDelay Lib "tinesrv32.dll" (ByVal msec As Long) As Long
Declare Function RedirectProperty Lib "tinesrv32.dll" (ByVal LocalName$, ByVal prpName$, ByVal redirector$) As Integer
Declare Function RedirectDeviceName Lib "tinesrv32.dll" (ByVal LocalName$, ByVal DevName$, ByVal redirector$) As Integer
Declare Sub SetRedirectionParameters Lib "tinesrv32.dll" (ByVal LocalName$, ByVal rdrContext As String, ByVal rdrServer As String, ByVal rdrDevice As String, ByVal rdrProperty As String)
Declare Function sendNetGlobal Lib "tinesrv32.dll" (ByVal Keyword$, data As Any, ByVal size As Long, ByVal fmt As Long, ByVal minPeriod As Long, ByVal maxPeriod As Long, ByVal tolerance As Double) As Long
Declare Function ScheduleProperty Lib "tinesrv32.dll" (ByVal LocalName$, ByVal property$) As Integer
Declare Function srvAssignBufferSpace Lib "tinesrv32.dll" (ByVal rcvBufferSize As Long, ByVal sndBufferSize As Long) As Integer
Declare Function SetContractListSize Lib "tinesrv32.dll" (ByVal numContracts As Long) As Long
Declare Function SetConsumerListSize Lib "tinesrv32.dll" (ByVal numConsumers As Long) As Long
Declare Function getDataTimeStamp Lib "tinesrv32.dll" () As Double
Declare Function makeDataTimeStamp Lib "tinesrv32.dll" () As Double
Declare Sub setDataTimeStamp Lib "tinesrv32.dll" (ByVal ts As Double)
Declare Sub SetSystemDataStamp Lib "tinesrv32.dll" (ByVal v As Long)
Declare Sub setSystemPresetMemory Lib "tinesrv32.dll" (ByVal v As Long)
Declare Sub setGlobalSynchronization Lib "tinesrv32.dll" (ByVal v As Long)
Declare Function GetLocalHistoryData Lib "tinesrv32.dll" (ByVal LocalName$, ByVal prpName$, ByVal DevName$, dout As DTYPE, din As DTYPE) As Integer
Declare Sub setRetardContractRemoval Lib "tinesrv32.dll" (ByVal v As Long)
Declare Sub setAppVersion Lib "tinesrv32.dll" (ByVal major As Long, ByVal minor As Long, ByVal revision As Long)
Declare Sub setAppDateFromString Lib "tinesrv32.dll" (ByVal DateString As String)
Declare Sub SetServerWaiting Lib "tinesrv32.dll" (ByVal isWaiting As Long)
Declare Sub SetServerCycleIdle Lib "tinesrv32.dll" (ByVal isIdle As Long)
Declare Function SetSynchronizationDeadband Lib "tinesrv32.dll" (ByVal deadband As Double) As Double
Declare Sub SetIgnoreCommonFiles Lib "tinesrv32.dll" (ByVal ignore As Long)
Declare Function GetIgnoreCommonFiles Lib "tinesrv32.dll" () As Integer
Declare Sub SetUseStandardHistoryFiles Lib "tinesrv32.dll" (ByVal useStandardFiles As Long)
Declare Function SetFreeBlocksAlarmThreshold Lib "tinesrv32.dll" (ByVal path As String, ByVal minFreeBlocks As Long) As Integer

Declare Function GetExportedContext Lib "tinesrv32.dll" (ByVal LocalName$, ByVal context$) As Integer
Declare Function GetExportedSubSystem Lib "tinesrv32.dll" (ByVal LocalName$, ByVal subsystem$) As Integer
Declare Function GetExportedFecName Lib "tinesrv32.dll" (ByVal FecName$) As Integer
Declare Function GetExportedName Lib "tinesrv32.dll" (ByVal LocalName$, ByVal ExportName$) As Integer
Declare Function SetSystemUserName Lib "tinesrv32.dll" (ByVal usrName As String) As Integer
Declare Sub SetExportedContext Lib "tinesrv32.dll" (ByVal LocalName$, ByVal context$)

Declare Function attachServer Lib "TBufferedSrv.dll" Alias "AttachServer" (ByVal ExportName As String, ByVal LocalName As String, ByVal ndevices As Long) As Integer
Declare Function RegisterDeviceName Lib "TBufferedSrv.dll" (ByVal DevName As String, ByVal devNumber As Integer) As Integer
Declare Function RegisterBufferedProperty Lib "TBufferedSrv.dll" ( _
  ByVal prpName As String, ByVal prpInSiz As Long, ByVal prpInFmt As Integer, _
  ByVal prpOutSiz As Long, ByVal prpOutFmt As Integer, ByVal prpMax As Single, _
  ByVal prpMin As Single, ByVal prpEgu As String, ByVal access As Integer, ByVal prpDescription As String _
) As Integer
  
Declare Function pushBufferedData Lib "TBufferedSrv.dll" ( _
  ByVal prpName As String, ByVal DevName As String, prpData As Any, _
  ByVal prpSiz As Long, ByVal prpSchedule As Integer _
) As Integer
Declare Function pullBufferedData Lib "TBufferedSrv.dll" ( _
  ByVal prpName As String, ByVal DevName As String, prpData As Any, ByVal prpSiz As Long _
) As Integer
Declare Function hasInputChanged Lib "TBufferedSrv.dll" (ByVal prpName As String) As Integer
Declare Function RegisterServerCallback Lib "TBufferedSrv.dll" (ByVal prpName As String, ByVal cb As Any) As Integer
Declare Function GetRegisteredProperties Lib "TBufferedSrv.dll" (prpNames As NAME32, nPrpNames As Integer) As Integer
Declare Function AttachDatabase Lib "TBufferedSrv.dll" () As Integer
Declare Function SetBufferedCompletion Lib "TBufferedSrv.dll" (ByVal completionCode As Long) As Integer
Declare Function GetInputDeviceNumber Lib "TBufferedSrv.dll" () As Integer
Declare Function getNotifiedProperty Lib "tbufsrv.dll" Alias "getNotifiedPropertyA" (ByVal prpName As String) As Long
Declare Function GetLastCaller Lib "tbufsrv.dll" Alias "GetLastCallerA" (ByVal UserName As String, ByVal ipaddr As String) As Integer

Type HistorySpecification
  pollingRate As Long
  archiveRate As Long
  depthInSeconds As Long
  depthInMonths As Long
  heartbeat As Long
  pTolerance As Single
  aTolerance As Single
  rhsServerName As Long
  rhsPropertyName As Long
End Type

' flags for AppendHistoryInformationEx
Global Const USE_POI_DEFAULT = &H0
Global Const USE_POI_RANGE = &H1
Global Const USE_POI_TOLERANCE = &H2
Global Const USE_POI_NONE = &H4

Declare Function AppendHistoryInformation Lib "tinesrv32.dll" (ByVal LocalName$, ByVal property$, ByVal device$, ByVal Length As Long, ByVal fmt As Long, ByVal idx As Long, hspec As HistorySpecification) As Long
Declare Function AppendHistoryInformationEx Lib "tinesrv32.dll" (ByVal LocalName$, ByVal property$, ByVal device$, ByVal Length As Long, ByVal fmt As Long, ByVal idx As Long, hspec As HistorySpecification, ByVal Flags As Long) As Long
Declare Function useMsecHistoryTimeStamps Lib "tinesrv32.dll" (ByVal useMSecTime As Long) As Long
'
'   RPC Access modes

Global Const CA_READ = &H1
Global Const CA_WRITE = &H2
Global Const CA_WRITEREAD = &H3
Global Const CA_ASYNC = &H4
Global Const CA_SYNC = &H8
Global Const CA_ALARM = &H10
Global Const CA_HIST = &H20
Global Const CA_FIRST = &H40
Global Const CA_LAST = &H80
Global Const CA_RETRY = &H100
Global Const CA_NETWORK = &H200
Global Const CA_CONNECT = &H2000
Global Const CA_MUTABLE = &H4000

'
'   RPC Error Definitions
Global Const success% = 0
Global Const illegal_line% = 1
Global Const illegal_format% = 2
Global Const illegal_arithmetic% = 3
Global Const ambiguous% = 4
Global Const illegal_delimiter% = 5
Global Const zero_divide% = 6
Global Const WA_full% = 7
Global Const non_existent% = 8
Global Const wrong_type% = 9
Global Const link_exhausted% = 10
Global Const not_properly% = 11
Global Const un_allocated% = 12
Global Const no_such_line% = 13
Global Const illegal_data_size% = 14
Global Const io_error% = 15
Global Const illegal_context% = 16
Global Const runtime_error% = 17
Global Const system_error% = 18
Global Const hardware_busy% = 19
Global Const argument_list_error% = 20
Global Const invalid_parameter% = 20
Global Const file_error% = 21
Global Const user_stream_transport% = 22
Global Const dimension_error% = 23
Global Const t_dimension_error% = 23
Global Const square_root_negative% = 24
Global Const buffer_too_small% = 25
Global Const string_too_long% = 26
Global Const ipx_socket_error% = 27
Global Const net_read_error% = 28
Global Const not_ready% = 29
Global Const invalid_transport_size% = 30
Global Const log_negative% = 31
Global Const device_not_connected% = 32
Global Const unauthorised_action% = 33
Global Const hardware_error% = 34
Global Const illegal_equipment_number% = 35
Global Const illegal_device_number% = 35
Global Const illegal_device% = 35
Global Const illegal_property% = 36
Global Const out_of_range% = 37
Global Const not_implemented% = 38
Global Const no_such_computer% = 39
Global Const struct_sealed% = 40
Global Const syntax_error% = 41
Global Const no_such_file% = 42
Global Const file_already_exists% = 43
Global Const no_file_space% = 44
Global Const link_not_open% = 45
Global Const remitted_data_lost% = 46
Global Const end_of_file% = 47
Global Const archive_busy% = 48
Global Const server_name_in_use% = 49
Global Const no_such_column% = 50
Global Const out_of_client_memory% = 51
Global Const def_area_full% = 52
Global Const address_unresolved% = 53
Global Const invalid_property% = 54
Global Const address_unknown% = 55
Global Const name_unknown% = 56
Global Const invalid_keyword% = 57
Global Const invalid_link% = 58
Global Const string_expected% = 59
Global Const out_of_local_memory% = 60
Global Const out_of_shared_memory% = 61
Global Const invalid_structure_tag% = 62
Global Const invalid_index% = 63
Global Const illegal_equipment_name% = 64
Global Const link_error% = 65
Global Const code_failure% = 66
Global Const non_existent_server% = 67
Global Const wrong_hexa% = 68
Global Const wrong_octal% = 69
Global Const illegal_character% = 70
Global Const illegal_operator% = 71
Global Const not_allowed% = 72
Global Const illegal_read_write% = 73
Global Const out_of_memory% = 74
Global Const database_not_loaded% = 75
Global Const illegal_command% = 76
Global Const resources_exhausted% = 77
Global Const file_not_open% = 78
Global Const hardware_bus_error% = 79
Global Const no_such_loop% = 80
Global Const driver_not_installed% = 82
Global Const port_not_available% = 83
Global Const scan_error% = 84
Global Const no_high_voltage% = 85
Global Const non_existent_elem% = 86
Global Const non_existent_fec% = 87
Global Const non_existent_client% = 88
Global Const cannot_lock% = 89
Global Const not_running% = 90
Global Const not_posted% = 91
Global Const not_accepted% = 92
Global Const operation_timeout% = 93
Global Const illegal_protocol% = 94
Global Const gpib_error% = 95
Global Const rs232_error% = 96
Global Const operation_busy% = 97
Global Const connection_timeout% = 98
Global Const illegal_mode% = 99
Global Const not_owner% = 100
Global Const not_defined% = 101
Global Const net_write_error% = 102
Global Const invalid_data% = 103
Global Const software_error% = 104
Global Const access_denied% = 105
Global Const tcp_not_supported% = 106
Global Const ipx_not_supported% = 107
Global Const host_not_resolved% = 108
Global Const tcp_connect_error% = 109
Global Const tcp_socket_error% = 110
Global Const configuration_error% = 111
Global Const invalid_return_code% = 112
Global Const link_blacklisted% = 113
Global Const link_exists% = 114
Global Const max_alarms_exceeded% = 115
Global Const not_exported% = 116
Global Const is_switching% = 117
Global Const at_limit% = 118
Global Const get_subscription_id% = 119
Global Const renegotiate_contract% = 120
Global Const server_redirection% = 121
Global Const value_too_high% = 122
Global Const value_too_low% = 123
Global Const warn_too_high% = 124
Global Const warn_too_low% = 125
Global Const completion_waiting% = 126
Global Const cannot_select% = 127
Global Const has_query_function% = 128
Global Const not_signalled% = 129
Global Const call_redirection% = 130
Global Const udp_socket_error% = 131
Global Const mutex_error% = 132
Global Const data_not_local% = 133
Global Const name_already_exists% = 134
Global Const already_assigned% = 135
Global Const invalid_field% = 136
Global Const mcast_init_error% = 137
Global Const invalid_mcast_group% = 138
Global Const non_existent_function% = 139
Global Const property_is_mca% = 140
Global Const invalid_name% = 141
Global Const invalid_value% = 142
Global Const device_error% = 143
Global Const device_not_ready% = 144
Global Const device_busy% = 145
Global Const invalid_interval% = 146
Global Const notification_pending% = 147
Global Const thread_error% = 148
Global Const is_terminating% = 149
Global Const name_server_unknown% = 150
Global Const lock_required% = 151
Global Const not_initialized% = 152
Global Const invalid_structure_size% = 153
Global Const canbus_error% = 154
Global Const profibus_error% = 155
Global Const data_stale% = 156
Global Const has_bitfield_tag% = 157
Global Const not_locked% = 158
Global Const lock_expired% = 159

Global Const not_registered% = 160
Global Const non_existent_property% = 161
Global Const memory_overwrite% = 162
Global Const server_idle% = 163
Global Const not_applicable% = 164
Global Const access_locked% = 165
Global Const invalid_reference% = 166
Global Const has_structure_tag% = 167
Global Const warn_disk_space% = 168
Global Const low_disk_space% = 169

Global Const information_static = 170
Global Const reset_mca_property = 171
Global Const record_too_long = 172
Global Const unix_socket_error = 173
Global Const pipe_error = 173
Global Const shm_error = 174



Global Const CE_SENDDATA = &H4000
Global Const CE_REDIRECTED = &H8000
Global Const CE_RENEGOTIATE = &H2000

Declare Sub MEMCPY Lib "utils32.dll" (dst As Any, src As Any, ByVal nBytes%)

Sub AssignFecApplicationInfo()
Dim ft As Long
Dim fn As String
Dim fs, f, s
Dim ds As String
Dim errcnt As Integer

On Error GoTo AssignFecApplicationInfoErr
setAppVersion App.major, App.minor, App.revision

Set fs = CreateObject("Scripting.FileSystemObject")
fn = App.ExeName + ".exe"
Set f = fs.GetFile(fn)
ds = format(f.DateLastModified, "DD-MM-YYYY hh:mm:ss")
setAppDateFromString ds
Exit Sub
AssignFecApplicationInfoErr:
errcnt = errcnt + 1
If errcnt = 1 Then ' give this one try in case we're in VB design mode
  fn = App.path + "\" + App.Title + ".exe"
  Resume
End If
Exit Sub
End Sub

Function GetBaseStatusCode(ByVal Status As Integer) As Integer
Dim code As Long
code = Status
If code < 0 Then code = code + 65536
GetBaseStatusCode = CInt(code And &HFFF)
End Function
Function GetDeviceServerForFec(devcontext As String, devfec As String, devservers() As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim srvs(10) As NAME32
Dim fecn As NAME16
Dim DevName As String
Dim rc As Integer, i%
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
BARR fecn.nam(), Trim$(devfec)
DevName = "/SITE/ENS/" + devcontext
dbout.dArrayLength = 10: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(DevName, "TAGS", dbout, srvs(0), dbin, fecn, CA_READ + CA_RETRY, 3000)
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim devservers(n)
For i% = 0 To n - 1
  devservers(i%) = Trim$(BSTR(srvs(i%).nam()))
Next
exitFunction:
GetDeviceServerForFec = rc%

End Function

Function GetEquipmentDeviceContextsForServer(devServer As String, contexts() As String, ncontexts As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim ctxs() As NAME32, devsrv As NAME32
Dim DevName As String
Dim rc As Integer, i%
If Len(devServer) = 0 Then
  GetEquipmentDeviceContextsForServer = argument_list_error
  Exit Function
Else
  dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
  BARR devsrv.nam(), Trim$(devServer)
End If
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
DevName = "/SITE/ENS"
ReDim ctxs(100)
dbout.dArrayLength = 100: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(DevName, "CONTEXTS", dbout, ctxs(0), dbin, devsrv, CA_READ + CA_RETRY, 3000)
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim contexts(n)
For i% = 0 To n - 1
  contexts(i%) = Trim$(BSTR(ctxs(i%).nam()))
Next
exitFunction:
ncontexts = n
GetEquipmentDeviceContextsForServer = rc%

End Function

Function GetEquipmentDeviceSubsystems(ByVal context As String, SubSystems() As String, nSubsystems As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim subs() As NAME16
Dim DevName As String
Dim rc As Integer, i%
If Len(context) = 0 Then
  GetEquipmentDeviceSubsystems = argument_list_error
  Exit Function

End If
DevName = "/SITE/ENS/" + context
ReDim subs(100)
dbout.dArrayLength = 100: dbout.dFormat = CF_NAME16
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
rc = T_EXECLINK(DevName, "SUBSYSTEMS", dbout, subs(0), dbin, 0, CA_READ + CA_RETRY, 3000)
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim SubSystems(n)
For i% = 0 To n - 1
  SubSystems(i%) = Trim$(BSTR(subs(i%).nam()))
Next
exitFunction:
nSubsystems = n
GetEquipmentDeviceSubsystems = rc%

End Function

Function isBitFieldFormat(ByVal fmt As Integer) As Boolean
fmt = (fmt Mod 256) + CF_DOUBLE
If fmt >= CF_BITFIELD8 And fmt <= CF_BITFIELD64 Then
  isBitFieldFormat = True
Else
  isBitFieldFormat = False
End If
End Function

Function GetFormatSize(ByVal fmt As Integer)
If fmt < CF_DOUBLE Then fmt = fmt + CF_DOUBLE
Select Case fmt
  Case CF_DOUBLE: GetFormatSize = 8
  Case CF_SHORT: GetFormatSize = 2
  Case CF_BYTE: GetFormatSize = 1
  Case CF_LONG: GetFormatSize = 4
  Case CF_TEXT: GetFormatSize = 1
  Case CF_FLOAT: GetFormatSize = 4
  Case CF_STRUCT: GetFormatSize = 1
  Case CF_NAME8: GetFormatSize = 8
  Case CF_NAME16: GetFormatSize = 16
  Case CF_CHAR16FI: GetFormatSize = 16 + 4 + 4
  Case CF_BIT: GetFormatSize = 1
  Case CF_NAME32: GetFormatSize = 32
  Case CF_FLTINT: GetFormatSize = 8
  Case CF_LNGINT: GetFormatSize = 8
  Case CF_DBLINT: GetFormatSize = 12
  Case CF_IFI: GetFormatSize = 12
  Case CF_NAME48: GetFormatSize = 48
  Case CF_NAME8I: GetFormatSize = 12
  Case CF_NAME16I: GetFormatSize = 20
  Case CF_NAME32I: GetFormatSize = 36
  Case CF_NAME48I: GetFormatSize = 52
  Case CF_USTRING: GetFormatSize = 96
  Case CF_FLTFLTINT: GetFormatSize = 12
  Case CF_FLTINTINT: GetFormatSize = 12
  Case CF_INTFLTFLTFLT: GetFormatSize = 16
  Case CF_SPECTRUM: GetFormatSize = 4
  Case CF_INTINTINTINT: GetFormatSize = 16
  Case CF_TTII: GetFormatSize = 16
  Case CF_FLTFLT: GetFormatSize = 8
  Case CF_INTFLTSHTSHT: GetFormatSize = 12
  Case CF_BOOLEAN: GetFormatSize = 4
  Case CF_INTINTFLTFLT: GetFormatSize = 16
  Case CF_FLTINTFLTINT: GetFormatSize = 16
  Case CF_NAME64: GetFormatSize = 64
  Case CF_NAME64I: GetFormatSize = 68
  Case CF_LNGDBL: GetFormatSize = 12
  Case CF_DBLDBL: GetFormatSize = 16
  Case CF_DBLDBLDBL: GetFormatSize = 24
  Case CF_NAME16DBLDBL: GetFormatSize = 32
  Case CF_NAME32DBLDBL: GetFormatSize = 48
  Case CF_NAME64DBLDBL: GetFormatSize = 80
  Case CF_NAME64DBL: GetFormatSize = 72
  Case CF_UNAME: GetFormatSize = 32
  Case CF_XML: GetFormatSize = 1
  Case CF_BITFIELD8: GetFormatSize = 8
  Case CF_BITFIELD16: GetFormatSize = 16
  Case CF_BITFIELD32: GetFormatSize = 32
  Case CF_BITFIELD64: GetFormatSize = 64
  Case CF_INT64: GetFormatSize = 8
  Case Else: GetFormatSize = 0
End Select
End Function
Function GetFormatAsString(ByVal fmt As Integer) As String
If fmt < CF_DOUBLE Then fmt = fmt + CF_DOUBLE
Select Case fmt
  Case CF_DOUBLE: GetFormatAsString = "DOUBLE"
  Case CF_SHORT: GetFormatAsString = "INT16"
  Case CF_BYTE: GetFormatAsString = "BYTE"
  Case CF_LONG: GetFormatAsString = "INT32"
  Case CF_DLONG: GetFormatAsString = "INT64"
  Case CF_TEXT: GetFormatAsString = "TEXT"
  Case CF_FLOAT: GetFormatAsString = "FLOAT"
  Case CF_STRUCT: GetFormatAsString = "STRUCT"
  Case CF_NAME8: GetFormatAsString = "NAME8"
  Case CF_NAME16: GetFormatAsString = "NAME16"
  Case CF_NAME16FI: GetFormatAsString = "NAME16FI"
  Case CF_NAME16II: GetFormatAsString = "NAME16II"
  Case CF_BIT: GetFormatAsString = "BIT"
  Case CF_HITTS: GetFormatAsString = "HITTS"
  Case CF_NAME32: GetFormatAsString = "NAME32"
  Case CF_FLTINT: GetFormatAsString = "FLTINT"
  Case CF_LNGINT: GetFormatAsString = "LNGINT"
  Case CF_DBLINT: GetFormatAsString = "DBLINT"
  Case CF_IFI: GetFormatAsString = "INTFLTINT"
  Case CF_NAME48: GetFormatAsString = "NAME48"
  Case CF_NAME8I: GetFormatAsString = "NAME8I"
  Case CF_NAME16I: GetFormatAsString = "NAME16I"
  Case CF_NAME32I: GetFormatAsString = "NAME32I"
  Case CF_NAME48I: GetFormatAsString = "NAME48I"
  Case CF_USTRING: GetFormatAsString = "USTRING"
  Case CF_USTRING: GetFormatAsString = "UNAME"
  Case CF_FLTFLTINT: GetFormatAsString = "FLTFLTINT"
  Case CF_FLTINTINT: GetFormatAsString = "FLTINTINT"
  Case CF_INTFLTFLTFLT: GetFormatAsString = "INTFLTFLTFLT"
  Case CF_SPECTRUM: GetFormatAsString = "SPECTRUM"
  Case CF_INTINT: GetFormatAsString = "INTINT"
  Case CF_INTINTINT: GetFormatAsString = "INTINTINT"
  Case CF_INTINTINTINT: GetFormatAsString = "INTINTINTINT"
  Case CF_TTII: GetFormatAsString = "WINDOW"
  Case CF_FLTFLT: GetFormatAsString = "FLTFLT"
  Case CF_INTFLTSHTSHT: GetFormatAsString = "INTFLTSHTSHT"
  Case CF_BOOLEAN: GetFormatAsString = "BOOLEAN"
  Case CF_INTINTFLTFLT: GetFormatAsString = "INTINTFLTFLT"
  Case CF_FLTINTFLTINT: GetFormatAsString = "FLTINTFLTINT"
  Case CF_NAME64: GetFormatAsString = "NAME64"
  Case CF_NAME64I: GetFormatAsString = "NAME64I"
  Case CF_LNGDBL: GetFormatAsString = "LNGDBL"
  Case CF_DBLDBL: GetFormatAsString = "DBLDBL"
  Case CF_DBLDBLDBL: GetFormatAsString = "DBLDBLDBL"
  Case CF_NAME32DBLDBL: GetFormatAsString = "NAME32DBLDBL"
  Case CF_NAME64DBLDBL: GetFormatAsString = "NAME64DBLDBL"
  Case CF_NAME64DBL: GetFormatAsString = "NAME64DBL"
  Case CF_XML: GetFormatAsString = "XML"
  Case CF_BITFIELD8: GetFormatAsString = "BITFIELD8"
  Case CF_BITFIELD16: GetFormatAsString = "BITFIELD16"
  Case CF_BITFIELD32: GetFormatAsString = "BITFIELD32"
  Case CF_BITFIELD64: GetFormatAsString = "BITFIELD64"
  Case CF_SPECTRUM: GetFormatAsString = "DSPECTRUM"
  Case CF_IMAGE: GetFormatAsString = "DIMAGE"
  Case Else: GetFormatAsString = "NULL"
End Select
End Function
Function getFormatFromString(ByVal fmtstr As String) As Byte
fmtstr = UCase(fmtstr)
Select Case fmtstr
  Case "DOUBLE": getFormatFromString = CF_DOUBLE - CF_DOUBLE
  Case "INT16", "INTEGER", "SHORT": getFormatFromString = CF_SHORT - CF_DOUBLE
  Case "BYTE": getFormatFromString = CF_BYTE - CF_DOUBLE
  Case "INT32", "LONG": getFormatFromString = CF_LONG - CF_DOUBLE
  Case "INT64", "DLONG": getFormatFromString = CF_DLONG - CF_DOUBLE
  Case "TEXT": getFormatFromString = CF_TEXT - CF_DOUBLE
  Case "FLOAT": getFormatFromString = CF_FLOAT - CF_DOUBLE
  Case "SINGLE": getFormatFromString = CF_FLOAT - CF_DOUBLE
  Case "STRUCT": getFormatFromString = CF_STRUCT - CF_DOUBLE
  Case "CHAR8": getFormatFromString = CF_NAME8 - CF_DOUBLE
  Case "NAME8": getFormatFromString = CF_NAME8 - CF_DOUBLE
  Case "CHAR16": getFormatFromString = CF_NAME16 - CF_DOUBLE
  Case "NAME16": getFormatFromString = CF_NAME16 - CF_DOUBLE
  Case "NAME16FI": getFormatFromString = CF_NAME16FI - CF_DOUBLE
  Case "NAME16II": getFormatFromString = CF_NAME16II - CF_DOUBLE
  Case "NAME16DBLDBL": getFormatFromString = CF_NAME16DBLDBL - CF_DOUBLE
  Case "NAME32DBLDBL": getFormatFromString = CF_NAME32DBLDBL - CF_DOUBLE
  Case "NAME64DBLDBL": getFormatFromString = CF_NAME64DBLDBL - CF_DOUBLE
  Case "BIT": getFormatFromString = CF_BIT - CF_DOUBLE
  Case "HITTS": getFormatFromString = CF_HITTS - CF_DOUBLE
  Case "CHAR32": getFormatFromString = CF_NAME32 - CF_DOUBLE
  Case "NAME32": getFormatFromString = CF_NAME32 - CF_DOUBLE
  Case "FLTINT": getFormatFromString = CF_FLTINT - CF_DOUBLE
  Case "LNGINT": getFormatFromString = CF_LNGINT - CF_DOUBLE
  Case "INTINT": getFormatFromString = CF_LNGINT - CF_DOUBLE
  Case "DBLINT": getFormatFromString = CF_DBLINT - CF_DOUBLE
  Case "INTFLTINT": getFormatFromString = CF_IFI - CF_DOUBLE
  Case "TDS": getFormatFromString = CF_IFI - CF_DOUBLE
  Case "NAME48": getFormatFromString = CF_NAME48 - CF_DOUBLE
  Case "NAME8I": getFormatFromString = CF_NAME8I - CF_DOUBLE
  Case "NAME16I": getFormatFromString = CF_NAME16I - CF_DOUBLE
  Case "NAME32I": getFormatFromString = CF_NAME32I - CF_DOUBLE
  Case "NAME48I": getFormatFromString = CF_NAME48I - CF_DOUBLE
  Case "USTRING": getFormatFromString = CF_USTRING - CF_DOUBLE
  Case "UNAME": getFormatFromString = CF_UNAME - CF_DOUBLE
  Case "FLTFLTINT": getFormatFromString = CF_FLTFLTINT - CF_DOUBLE
  Case "FLTINTINT": getFormatFromString = CF_FLTINTINT - CF_DOUBLE
  Case "INTFLTFLTFLT": getFormatFromString = CF_INTFLTFLTFLT - CF_DOUBLE
  Case "DSPECTRUM", "SPECTRUM": getFormatFromString = CF_SPECTRUM - CF_DOUBLE
  Case "INTINTINT": getFormatFromString = CF_INTINTINT - CF_DOUBLE
  Case "ADDRESS": getFormatFromString = CF_INTINTINTINT - CF_DOUBLE
  Case "INTINTINTINT": getFormatFromString = CF_INTINTINTINT - CF_DOUBLE
  Case "WINDOW": getFormatFromString = CF_TTII - CF_DOUBLE
  Case "INTINTFLTFLT": getFormatFromString = CF_INTINTFLTFLT - CF_DOUBLE
  Case "FWINDOW": getFormatFromString = CF_INTINTFLTFLT - CF_DOUBLE
  Case "FLTFLT": getFormatFromString = CF_FLTFLT - CF_DOUBLE
  Case "INTFLTSHTSHT": getFormatFromString = CF_INTFLTSHTSHT - CF_DOUBLE
  Case "BOOLEAN": getFormatFromString = CF_BOOLEAN - CF_DOUBLE
  Case "INTINTFLTFLT": getFormatFromString = CF_INTINTFLTFLT - CF_DOUBLE
  Case "FLTINTFLTINT": getFormatFromString = CF_FLTINTFLTINT - CF_DOUBLE
  Case "NAME64": getFormatFromString = CF_NAME64 - CF_DOUBLE
  Case "NAME64I": getFormatFromString = CF_NAME64I - CF_DOUBLE
  Case "DBLDBL": getFormatFromString = CF_DBLDBL - CF_DOUBLE
  Case "DBLDBLDBL": getFormatFromString = CF_DBLDBLDBL - CF_DOUBLE
  Case "XML": getFormatFromString = CF_XML - CF_DOUBLE
  Case "BITFIELD8": getFormatFromString = CF_BITFIELD8 - CF_DOUBLE
  Case "BITFIELD16": getFormatFromString = CF_BITFIELD16 - CF_DOUBLE
  Case "BITFIELD32": getFormatFromString = CF_BITFIELD32 - CF_DOUBLE
  Case "BITFIELD64": getFormatFromString = CF_BITFIELD64 - CF_DOUBLE
  Case "NAME64DBL": getFormatFromString = CF_NAME64DBL - CF_DOUBLE
  Case "DIMAGE": getFormatFromString = CF_IMAGE - CF_DOUBLE
  Case Else: getFormatFromString = CF_NULL - CF_DOUBLE
End Select

End Function

Function GETCURRENT() As Double
Static er As String * 80
rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
If rc% = 0 Then
  GETCURRENT = HPCURRENT
Else
  rc% = RPCERR(rc%, er$)
  GETCURRENT = -1
End If
End Function

Function GETENERGY() As Integer
Static er As String * 80
rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
If rc% = 0 Then
  GETENERGY = HPENERGY
Else
  rc% = RPCERR(rc%, er$)
  GETENERGY = -1
End If
End Function

Function getGraphTypeAsString(ByVal graphType) As String
  Select Case graphType
    Case GT_LIN: getGraphTypeAsString = "LIN"
    Case GT_LOG: getGraphTypeAsString = "LOG"
    Case Else: getGraphTypeAsString = "LIN"
  End Select
End Function

Function getLogFile(ByVal SrvName As String, ByVal logName As String) As String
Dim textblob(32000) As Byte
Dim blogfile(32) As Byte
Dim dbout As DBLK
Dim dbin As DBLK
Dim rc As Integer

dbout.dArrayLength = 32000
dbout.dFormat = CF_TEXT
dbin.dArrayLength = Len(logName)
dbin.dFormat = CF_TEXT

BARR blogfile, logName
rc = EXECLINKEx(SrvName, "SRVLOGFILE", dbout, textblob(0), dbin, blogfile(0), CA_READ, 3000)
If rc = 0 Then
  getLogFile = BSTR(textblob)
Else
  getLogFile = "Error in logfile retrieval : " + RPCERROR(rc)
End If

End Function

Function HERAGetCurrent(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
       If HPCur < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HECur", HECURRENT, 1, CF_DOUBLE)
       If HECur < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetCurrent = rc%
End Function

Function HERAGetEnergy(ByVal t$) As Integer
Static hemagen As Single
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
       If HPENERGY < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEMAGEN", hemagen, 1, CF_FLOAT)
       HEENERGY = CInt(hemagen)
       If HEENERGY < 0 Then rc% = 91
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetEnergy = rc%
End Function

Function HERAGetLifetime(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPtau", HPTAU, 1, CF_DOUBLE)
       If HPTAU < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEtau", HETAU, 1, CF_DOUBLE)
       If HETAU < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetLifetime = rc%
End Function
Function GetEquipmentDevicePropertyInformation(DevName As String, Properties() As String, PropertySizes() As Integer, PropertyTypes() As Integer, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQueryEx
Dim prpsLegacy() As PropertyQuery
Dim rc As Integer, i As Integer, ni As Integer
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
getPropsAgain:
ReDim prps(n)
ReDim Properties(n): ReDim PropertySizes(n): ReDim PropertyTypes(n)
dbout.dArrayLength = CLng(n) * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(DevName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
If rc = invalid_transport_size Then
  n = n / 2
  GoTo getPropsAgain
End If
If rc = illegal_read_write Then  ' Ugh! legacy stuff -> why doesn't everybody upgrade ?
  ReDim prpsLegacy(n)
  dbout.dArrayLength = n * Len(prpsLegacy(0)): dbout.dFormat = CF_STRUCT
  rc = T_EXECLINK(DevName, "PROPS", dbout, prpsLegacy(0), dbin, Null, CA_READ, 3000)
  If rc = 0 Then
    i = 0
    For ni = 0 To n - 1
      Properties(i) = Trim$(BSTR(prpsLegacy(ni).prpName))
      PropertySizes(i) = prpsLegacy(ni).prpSize
      PropertyTypes(i) = prpsLegacy(ni).prpFormat + CF_DOUBLE
      If Len(Properties(i%)) > 0 Then i = i + 1
    Next
    n = i
    GoTo exitFunction
  End If
End If
If rc Then GoTo exitFunction
i = 0
For ni = 0 To n - 1
  Properties(i) = Trim$(BSTR(prps(ni).prpName))
  PropertySizes(i) = IIf(prps(ni).prpSize < 32767, prps(ni).prpSize, 32767)
  PropertyTypes(i) = prps(ni).prpFormat + CF_DOUBLE
  If Len(Properties(i%)) > 0 Then i = i + 1
Next
n = i
exitFunction:
nproperties = n
GetEquipmentDevicePropertyInformation = rc%
End Function
Function GetEquipmentDevicePropertyInformationEx(DevName As String, Properties() As String, PropertySizes() As Integer, PropertyTypes() As Integer, PropertyDescriptions() As String, PropertyMax() As Single, PropertyMin() As Single, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQueryEx
Dim prpsLegacy() As PropertyQuery
Dim rc As Integer, i As Integer, ni As Integer
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
getPropsAgain:
ReDim prps(n)
ReDim Properties(n): ReDim PropertySizes(n): ReDim PropertyTypes(n)
ReDim PropertyDescriptions(n)
ReDim PropertyMax(n): ReDim PropertyMin(n)
dbout.dArrayLength = CLng(n) * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(DevName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
If rc = invalid_transport_size Then
  n = n / 2
  GoTo getPropsAgain
End If
If rc = illegal_read_write Then  ' Ugh! legacy stuff -> why doesn't everybody upgrade ?
  ReDim prpsLegacy(n)
  dbout.dArrayLength = n * Len(prpsLegacy(0)): dbout.dFormat = CF_STRUCT
  rc = T_EXECLINK(DevName, "PROPS", dbout, prpsLegacy(0), dbin, Null, CA_READ, 3000)
  If rc = 0 Then
    i = 0
    For ni = 0 To n - 1
      Properties(i) = Trim$(BSTR(prpsLegacy(ni).prpName))
      PropertySizes(i) = prpsLegacy(ni).prpSize
      PropertyTypes(i) = prpsLegacy(ni).prpFormat + CF_DOUBLE
      If Len(Properties(i%)) > 0 Then i = i + 1
    Next
    n = i
    GoTo exitFunction
  End If
End If
If rc Then GoTo exitFunction
i = 0
For ni = 0 To n - 1
  Properties(i) = Trim$(BSTR(prps(ni).prpName))
  PropertySizes(i) = IIf(prps(ni).prpSize < 32767, prps(ni).prpSize, 32767)
  PropertyTypes(i) = prps(ni).prpFormat + CF_DOUBLE
  PropertyDescriptions(i) = BSTR(prps(ni).prpDesc)
  PropertyMax(i) = prps(ni).prpMaxValue
  PropertyMin(i) = prps(ni).prpMinValue
  If Len(Properties(i)) > 0 Then i = i + 1
Next
n = i
exitFunction:
nproperties = n
GetEquipmentDevicePropertyInformationEx = rc%
End Function

Function GetEquipmentDevicePropertyInformationExt(DevName As String, Properties() As String, PropertySizes() As Integer, PropertyTypes() As Integer, PropertyDescriptions() As String, PropertyMax() As Single, PropertyMin() As Single, PropertyUnits() As String, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim ntrap As Long
Dim prps() As PrpQuery 'PropertyQueryEx
Dim prpsLegacy() As PropertyQuery
Dim rc As Integer, i As Integer, ni As Integer
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
getPropsAgain:
ReDim prps(n)
ReDim Properties(n): ReDim PropertySizes(n): ReDim PropertyTypes(n)
ReDim PropertyDescriptions(n)
ReDim PropertyMax(n): ReDim PropertyMin(n)
ReDim PropertyUnits(n)

If n = 4000 Then ' a modern doocs specialty
  n = 1000
End If
If (n < 300) Or (n = 1000) Then ' n = 1000 => a doocs specialty
  dbout.dArrayLength = CLng(n): dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "PRPQSr4"
  rc = T_EXECLINK(DevName, "PROPS", dbout, prps(0), dbin, Null, CA_READ + CA_MUTABLE, 3000)
  If dbout.dArrayLength = 151 Then
    rc = illegal_format
  End If
  If rc = invalid_transport_size Then
    n = n / 2
    GoTo getPropsAgain
  End If
Else
  rc = illegal_format% ' force legacy call (registered struct PRPQs4 won't give more than 10)
End If
If rc = illegal_read_write Or rc = illegal_format% Or rc = invalid_structure_tag Then
  ntrap = CLng(n) * Len(prpsLegacy(0))
  If (ntrap Mod 188) = 0 Then n = n + 1 'avoid magic numbers
  ReDim prpsLegacy(n)
  dbout.dArrayLength = CLng(n) * Len(prpsLegacy(0)): dbout.dFormat = CF_STRUCT: BARR dbout.dTag, ""
  rc = T_EXECLINK(DevName, "PROPS", dbout, prpsLegacy(0), dbin, Null, CA_READ, 3000)
  If rc = 0 Then
    i = 0
    For ni = 0 To n - 1
      Properties(i) = Trim$(BSTR(prpsLegacy(ni).prpName))
      PropertySizes(i) = prpsLegacy(ni).prpSize
      PropertyTypes(i) = prpsLegacy(ni).prpFormat + CF_DOUBLE
      PropertyDescriptions(i) = BSTR(prpsLegacy(ni).prpDesc)
      If Len(Properties(i%)) > 0 Then i = i + 1
    Next
    n = i
    GoTo exitFunction
  End If
End If
If rc Then GoTo exitFunction
i = 0
For ni = 0 To n - 1
  Properties(i) = Trim$(BSTR(prps(ni).prpName))
  PropertySizes(i) = IIf(prps(ni).prpSize < 32767, prps(ni).prpSize, 32767)
  PropertyTypes(i) = prps(ni).prpFormat + CF_DOUBLE
  PropertyDescriptions(i) = BSTR(prps(ni).prpDsc)
  PropertyMax(i) = prps(ni).prpMaxValue
  PropertyMin(i) = prps(ni).prpMinValue
  PropertyUnits(i) = BSTR(prps(ni).prpUnits)
  If Len(Properties(i)) > 0 Then i = i + 1
Next
n = i
exitFunction:
nproperties = n
GetEquipmentDevicePropertyInformationExt = rc%
End Function

Function GetEquipmentDevicePropertyInformationL(DevName As String, Properties() As String, PropertySizes() As Long, PropertyTypes() As Integer, PropertyDescriptions() As String, PropertyMax() As Single, PropertyMin() As Single, PropertyUnits() As String, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim ntrap As Long
Dim prps() As PrpQuery 'PropertyQueryEx
Dim prpsLegacy() As PropertyQuery
Dim rc As Integer, i As Integer, ni As Integer
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
getPropsAgain:
ReDim prps(n)
ReDim Properties(n): ReDim PropertySizes(n): ReDim PropertyTypes(n)
ReDim PropertyDescriptions(n)
ReDim PropertyMax(n): ReDim PropertyMin(n)
ReDim PropertyUnits(n)

If (n < 300) Or (n = 1000) Then ' n = 1000 => a doocs specialty
  dbout.dArrayLength = CLng(n): dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "PRPQSr4"
  rc = T_EXECLINK(DevName, "PROPS", dbout, prps(0), dbin, Null, CA_READ + CA_MUTABLE, 3000)
  If dbout.dArrayLength = 151 Then
    rc = illegal_format
  End If
  If rc = invalid_transport_size Then
    n = n / 2
    GoTo getPropsAgain
  End If
Else
  rc = illegal_format% ' force legacy call (registered struct PRPQs4 won't give more than 10)
End If
If rc = illegal_read_write Or rc = illegal_format% Or rc = invalid_structure_tag Then
  ntrap = CLng(n) * Len(prpsLegacy(0))
  If (ntrap Mod 188) = 0 Then n = n + 1 'avoid magic numbers
  ReDim prpsLegacy(n)
  dbout.dArrayLength = CLng(n) * Len(prpsLegacy(0)): dbout.dFormat = CF_STRUCT: BARR dbout.dTag, ""
  rc = T_EXECLINK(DevName, "PROPS", dbout, prpsLegacy(0), dbin, Null, CA_READ, 3000)
  If rc = 0 Then
    i = 0
    For ni = 0 To n - 1
      Properties(i) = Trim$(BSTR(prpsLegacy(ni).prpName))
      PropertySizes(i) = prpsLegacy(ni).prpSize
      PropertyTypes(i) = prpsLegacy(ni).prpFormat + CF_DOUBLE
      PropertyDescriptions(i) = BSTR(prpsLegacy(ni).prpDesc)
      If Len(Properties(i%)) > 0 Then i = i + 1
    Next
    n = i
    GoTo exitFunction
  End If
End If
If rc Then GoTo exitFunction
i = 0
For ni = 0 To n - 1
  Properties(i) = Trim$(BSTR(prps(ni).prpName))
  PropertySizes(i) = prps(ni).prpSize
  PropertyTypes(i) = prps(ni).prpFormat + CF_DOUBLE
  PropertyDescriptions(i) = BSTR(prps(ni).prpDsc)
  PropertyMax(i) = prps(ni).prpMaxValue
  PropertyMin(i) = prps(ni).prpMinValue
  PropertyUnits(i) = BSTR(prps(ni).prpUnits)
  If Len(Properties(i)) > 0 Then i = i + 1
Next
n = i
exitFunction:
nproperties = n
GetEquipmentDevicePropertyInformationL = rc%
End Function


Function GetEquipmentDeviceProperties(DevName As String, Properties() As String, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQuery
Dim prpNames() As NAME64
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
ReDim prpNames(n)
ReDim Properties(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME64
rc = T_EXECLINK(DevName, "PROPS", dbout, prpNames(0), dbin, Null, CA_READ, 3000)
If (rc And CE_SENDDATA) = CE_SENDDATA Then rc = 0
If rc = illegal_format Then
  ReDim prps(n)
  dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
  rc = T_EXECLINK(DevName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
  If rc Then GoTo exitFunction
  For i% = 0 To n - 1
    Properties(i%) = Trim$(BSTR(prps(i).prpName))
  Next
End If
If rc Then GoTo exitFunction
For i% = 0 To n - 1
  Properties(i%) = Trim$(BSTR(prpNames(i%).nam))
Next
exitFunction:
nproperties = n
GetEquipmentDeviceProperties = rc%
End Function
Function GetEquipmentDevicePropertiesEx(DevName As String, Properties() As String, nproperties As Integer, hasQueryFunction As Boolean) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQuery
Dim prpNames() As NAME64
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NPROPS", dbout, n, dbin, Null, CA_READ, 800)
If rc Then GoTo exitFunction
ReDim prpNames(n)
ReDim Properties(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME64
rc = T_EXECLINK(DevName, "PROPS", dbout, prpNames(0), dbin, Null, CA_READ, 3000)
If (rc And has_query_function) = has_query_function Then hasQueryFunction = True Else hasQueryFunction = False
If (rc And CE_SENDDATA) = CE_SENDDATA Then rc = 0
If rc = illegal_format Then
  ReDim prps(n)
  dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
  rc = T_EXECLINK(DevName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
  If rc Then GoTo exitFunction
  For i% = 0 To n - 1
    Properties(i%) = Trim$(BSTR(prps(i).prpName))
  Next
End If
If rc Then GoTo exitFunction
For i% = 0 To n - 1
  Properties(i%) = Trim$(BSTR(prpNames(i%).nam))
Next
exitFunction:
nproperties = n
GetEquipmentDevicePropertiesEx = rc%
End Function

Function GetEquipmentDeviceHistories(DevName As String, Histories() As String, nHistories As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim hsts() As NAME32
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(DevName, "NHISTORIES", dbout, n, dbin, Null, CA_READ, 500)
'If rc = 45 Then
'    rc = T_EXECLINK(devName, "NHISTORIES", dbout, n, dbin, Null, CA_READ, 1500)
'End If
If rc <> 0 Or n <= 0 Then
    GoTo exitFunction
End If
ReDim hsts(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(DevName, "HISTORIES", dbout, hsts(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim Histories(n)
For i% = 0 To n - 1
  Histories(i%) = Trim$(BSTR(hsts(i).nam))
Next
exitFunction:
nHistories = n
GetEquipmentDeviceHistories = rc%
End Function

Function ISDST(ByVal vbDate As Date) As Boolean
' This routines needs utils32.dll and the declares for MKTIME, LCLTIME and Type for TM found in tine.bas
Dim ut As Long
Dim t As TM
t.tm_year = Year(vbDate)
t.tm_mon = Month(vbDate)
t.tm_mday = Day(vbDate)
t.tm_hour = Hour(vbDate)
t.tm_min = Minute(vbDate)
t.tm_sec = Second(vbDate)
t.tm_isdst = -1  ' I don't know, let it find out ...
ut = MKTIME(t)   ' the time as UTC
Call LCLTIME(ut, t)
ISDST = t.tm_isdst ' now I know !
End Function

Function isNumberFormat(ByVal fmt As Integer) As Boolean
Select Case fmt
  Case CF_INT16: Case CF_INT32: Case CF_FLOAT: Case CF_DOUBLE:
    isNumberFormat = True
  Case Else
    isNumberFormat = False
End Select
End Function

Function SetAccessLock(ByVal DevName As String, ByVal lockType As AccessLockTypes, lockDurationInSeconds As Integer)
Dim dbout As DBLK
Dim dbin As DBLK
Dim rc As Integer
Dim accLock(1) As Integer
Dim lt As Integer

lt = lockType
accLock(0) = lt
accLock(1) = lockDurationInSeconds
dbin.dArrayLength = 2: dbin.dFormat = CF_SHORT
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
rc = T_EXECLINK(DevName, "ACCESSLOCK", dbout, 0, dbin, accLock(0), CA_WRITE, 1000)
SetAccessLock = rc%
End Function
Function GetAccessLockInformation(ByVal DevName As String, clnName As String, clnAddr As String)
Dim dbout As DBLK
Dim dbin As DBLK
Dim accInfo(1) As NAME32
Dim rc As Integer
  
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 2: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(DevName, "ACCESSLOCK", dbout, accInfo(0), dbin, 0, CA_READ, 100)
If rc = 0 Then
  clnName = BSTR(accInfo(0).nam())
  clnAddr = BSTR(accInfo(1).nam())
End If
GetAccessLockInformation = rc%
End Function
Function GetPropertyInformation(DevName As String, property As String, DataLength As Long, DataFormat As Integer, Description As String) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prp As PropertyQueryEx
Dim rc As Integer, i%
Dim tgt As NAME32
  
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
BARR tgt.nam(), property
rc = T_EXECLINK(DevName, "PROPS", dbout, prp, dbin, tgt, CA_READ, 100)
If rc = 0 Then
  DataLength = prp.prpSize
  DataFormat = CF_DOUBLE + prp.prpFormat
  Description = BSTR(prp.prpDesc())
End If
GetPropertyInformation = rc%
End Function
Function GetPropertyInformationEx(DevName As String, property As String, prp As PropertyQueryEx) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim rc As Integer, i%
Dim tgt As NAME32
  
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
BARR tgt.nam(), property
rc = T_EXECLINK(DevName, "PROPS", dbout, prp, dbin, tgt, CA_READ, 100)
If rc = 0 And dbout.dArrayLength = 0 Then rc = illegal_property
GetPropertyInformationEx = rc
End Function
Function GetPropertyInformationList(ByVal DevName As String, prp() As String, desc() As String, fmt() As Integer, siz() As Long) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim rc As Integer, i%
Dim rb(200) As USTRING
Dim ba(64) As Byte
  
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 200: dbout.dFormat = CF_USTRING
rc = T_EXECLINK(DevName, "PROPS", dbout, rb(0), dbin, 0, CA_READ, 500)
If rc = 0 And dbout.dArrayLength = 0 Then
  rc = illegal_property
Else
  ReDim prp(dbout.dArrayLength)
  ReDim desc(dbout.dArrayLength)
  ReDim fmt(dbout.dArrayLength)
  ReDim siz(dbout.dArrayLength)
  For i = 0 To dbout.dArrayLength - 1
    MEMCPY ba(0), rb(i).STR(0), 32
    prp(i) = BSTR(ba)
    MEMCPY ba(0), rb(i).STR(32), 64
    desc(i) = BSTR(ba)
    siz(i) = rb(i).iVal
    fmt(i) = rb(i).ts
  Next
End If

GetPropertyInformationList = rc
End Function

Function GetPropertyListLegacy(DevName As String, prps() As String, siz() As Long, fmt() As Integer, desc() As String) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prp(199) As PropertyQuery
Dim rc As Integer, i%
  
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = Len(prp(0)) * 200: dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(DevName, "PROPS", dbout, prp(0), dbin, tgt, CA_READ, 100)
If rc = 0 Then
  n = dbout.dArrayLength / Len(prp(0))
  ReDim prps(n)
  ReDim desc(n)
  ReDim fmt(n)
  ReDim siz(n)
  For i = 0 To n - 1
    prps(i) = BSTR(prp(i).prpName())
    desc(i) = BSTR(prp(i).prpDesc())
    siz(i) = prp(i).prpSize
    fmt(i) = CF_DOUBLE + prp(i).prpFormat
  Next
End If
GetPropertyListLegacy = rc%
End Function

Function GetFullPropertyInformation(DevName As String, property As String, prp As XPropertyQuery) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim rc As Integer, i%
Dim tgt As NAME32
Static done As Boolean

If Not done Then
  done = True
  FILLSTRUCT "XPQS", Len(prp), 1, CF_NULL
End If
  
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
dbout.dArrayLength = 1: dbout.dFormat = CF_STRUCT: BARR dbout.dTag, "XPQS"
BARR tgt.nam(), property
rc = T_EXECLINK(DevName, "PROPS", dbout, prp, dbin, tgt, CA_READ, 1000)
If rc = 0 And dbout.dArrayLength = 0 Then rc = illegal_property
GetFullPropertyInformation = rc
End Function

Function GetEquipmentEGU(DevName As String, devProperty As String, eguMin As Single, eguMax As Single, egu As String) As Integer
Dim u As USTRING
Dim dout As DBLK, din As DBLK
Dim rc As Integer
Dim devPrp As String

din.dArrayLength = 0: din.dFormat = CF_NULL
dout.dArrayLength = 1: dout.dFormat = CF_USTRING
devPrp = devProperty + ".EGU"
rc = T_EXECLINK(DevName, devPrp, dout, u, din, 0, CA_READ, 500)
If rc Then
 GetEquipmentEGU = rc
 Exit Function
End If
eguMin = u.f1val
eguMax = u.f2val
egu$ = BSTR(u.STR())
GetEquipmentEGU = 0
End Function
Function GetEquipmentExtEGU(DevName As String, devProperty As String, eguMin As Single, eguMax As Single, egu As String, eguType As Integer) As Integer
Dim u As USTRING
Dim dout As DBLK, din As DBLK
Dim rc As Integer
Dim devPrp As String

din.dArrayLength = 0: din.dFormat = CF_NULL
dout.dArrayLength = 1: dout.dFormat = CF_USTRING
devPrp = devProperty + ".EGU"
rc = T_EXECLINK(DevName, devPrp, dout, u, din, 0, CA_READ, 500)
If rc Then
 GetEquipmentExtEGU = rc
 Exit Function
End If
eguMin = u.f1val
eguMax = u.f2val
eguType = u.iVal
egu$ = BSTR(u.STR())
GetEquipmentExtEGU = 0
End Function
Function GetEquipmentDeviceNames(devServer As String, devNames() As String, ndevices As Integer) As Integer
Dim hqf As Boolean
GetEquipmentDeviceNames = GetEquipmentDeviceNamesEx(devServer, devNames, ndevices, hqf)
End Function
Function GetEquipmentDeviceNamesEx(devServer As String, devNames() As String, ndevices As Integer, hasQueryFunction As Boolean) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Long
Dim bnms() As Byte
Dim nm As NAME64
Dim nLen As Long, nFmt As Long
Dim rc As Integer
Dim i As Long, j As Long
Dim dev As String
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devServer, "NDEVICES", dbout, n, dbin, Null, CA_READ + CA_RETRY, 800)
If rc = non_existent_elem Then
  n = 512 ' try this
  rc = 0
End If
If rc Then GoTo exitFunction
nLen = 64
nFmt = CF_NAME64
ReDim bnms(n * nLen)
retryFormat:
dbout.dArrayLength = n: dbout.dFormat = nFmt
rc = T_EXECLINK(devServer, "DEVICES", dbout, bnms(0), dbin, Null, CA_READ + CA_RETRY, 3000)
If rc = illegal_format And nFmt = CF_NAME64 Then
  nFmt = CF_NAME16
  nLen = 16
  GoTo retryFormat
End If
If (rc And has_query_function) = has_query_function Then hasQueryFunction = True Else hasQueryFunction = False
If (rc And CE_SENDDATA) = CE_SENDDATA Then
  rc = 0
End If
If rc Then GoTo exitFunction
ReDim devNames(n): j = 0
For i = 0 To n - 1
  MEMCPY nm.nam(0), bnms(i * nLen), nLen
  dev = Trim$(BSTR(nm.nam()))
  If Len(dev) = 0 And nFmt = CF_NAME64 And i = 0 Then
    nFmt = CF_NAME16
    nLen = 16
    GoTo retryFormat
  End If
  If Right$(dev, 1) = "&" And Len(dev) = 16 Then
    i = i + 1
    MEMCPY nm.nam(0), bnms(i * nLen), nLen
    dev = Left$(dev, 15) + Trim$(BSTR(nm.nam()))
  End If
  If Len(dev) > 0 Then
    devNames(j) = dev
    j = j + 1
  End If
Next
exitFunction:
ndevices = j
GetEquipmentDeviceNamesEx = rc
End Function

Function GetEquipmentDeviceNamesFromProperty(devServer As String, devProperty As String, devNames() As String, ndevices As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim nFmt As Integer
Dim n As Long, nLen As Long
Dim nm64 As NAME64
Dim bnms() As Byte
Dim rc As Integer, i%, j%
Dim dev As String
Dim nretry%, Timeout&

Timeout& = 1000
nretry% = 0

n = ndevices
nLen = 64
nFmt = CF_NAME64
retryGet:
If n = 0 Then n = 1000

ReDim bnms(n * nLen)
dbout.dArrayLength = n: dbout.dFormat = nFmt
TryReTry:

rc = T_EXECLINK(devServer + "/#0", devProperty + ".NAM", dbout, bnms(0), dbin, Null, CA_READ + CA_RETRY, Timeout&)
If (rc = link_not_open% Or rc = connection_timeout%) And nretry% < 3 Then
    Timeout& = Timeout& + 500
    nretry% = nretry% + 1
    MsgBox "Error " + devServer + "/#0" + " and property " + devProperty + ".NAM" + ":  " + RPCERROR(rc)
    GoTo TryReTry
ElseIf rc = illegal_format And nFmt = CF_NAME64 Then
  nFmt = CF_NAME16
  nLen = 16
  GoTo retryGet
End If
If (rc And CE_SENDDATA) = CE_SENDDATA Then
  rc = 0
End If
If rc = invalid_transport_size Then
  n = n / 2
  GoTo retryGet
End If
If rc Then GoTo exitFunction

If dbout.dArrayLength < ndevices And dbout.dArrayLength > 0 Then
  MEMCPY nm64.nam(0), bnms(0), nLen
  If BSTR(nm64.nam()) = "#0" Then
    ReDim devNames(n): j% = 0
    For i% = 0 To n - 1: devNames(i%) = "#" + Trim$(STR(i)):  Next
    GetEquipmentDeviceNamesFromProperty = 0
    Exit Function
  End If
End If
n = dbout.dArrayLength

' How can this happen? SIZE is ZERO?
If n = 0 Then Exit Function

ReDim devNames(n - 1): j% = 0
For i% = 0 To n - 1
  MEMCPY nm64.nam(0), bnms(i% * nLen), nLen
  dev = Trim$(BSTR(nm64.nam()))
  If Right$(dev, 1) = "&" And Len(dev) = 16 Then
    i% = i% + 1
    MEMCPY nm64.nam(0), bnms(i% * nLen), nLen
    dev = Left$(dev, 15) + Trim$(BSTR(nm64.nam()))
  End If
  If Len(dev) > 0 Then
    devNames(j%) = dev
    j% = j% + 1
  End If
Next
exitFunction:
ndevices = j%
GetEquipmentDeviceNamesFromProperty = rc
End Function

Function RPCERROR(ByVal rc%) As String
Static rpcerrbuff As String * 80
cc% = RPCERR(rc%, rpcerrbuff)
If cc% Then
  RPCERROR = "Error undefined"
Else
  RPCERROR = Left$(rpcerrbuff, InStr(rpcerrbuff, Chr(0)) - 1)
End If
End Function

Function UserName() As String
cc% = GETUSER(netuser$)
UserName = UCase(Left$(netuser$, InStr(netuser$, Chr(0)) - 1))
End Function
Function BSTR(B() As Byte) As String
Dim s As String * 32767
Dim t As String
Dim tok() As String
Dim numBytes As Integer
Dim lnb As Long
lnb = UBound(B) - LBound(B) + 1
If lnb > 32767 Then lnb = 32767
numBytes = lnb
'If numBytes > 32767 Then numBytes = 32767
Call Bytes2String(s, B(LBound(B)), numBytes)
anz = InStr(s, Chr(0)) - 1
If anz >= 0 Then
    t = Left$(s, InStr(s, Chr(0)) - 1)
Else
    t = s
End If
If InStr(t, Chr(10)) Then
    tok = Split(t, Chr(10))
    t = ""
    For i = 0 To UBound(tok)
      t = t + tok(i) + vbNewLine
    Next
End If
BSTR = t
End Function

Function BARR(B() As Byte, s As String) As Integer
Dim numBytes&, strlen%, i%
numBytes& = UBound(B) - LBound(B) + 1
strlen% = Len(s)
If strlen% > numBytes& Then
  BARR = 0
Else
  Call String2Bytes(B(LBound(B)), s, strlen%)
  If numBytes& > strlen% Then B(LBound(B) + strlen%) = 0
  BARR = strlen%
End If
End Function
Function GetFecInfoFromNameServer(ByVal FecName As String, finfo As RPCFECINFO_R4, eqps() As String, neqps As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim DevName As String
Dim eqpnames(24) As NAME32
Dim txtbuf(208 + 25 * 32) As Byte
Dim rc As Integer, i%, pos%

dbout.dArrayLength = 208 + 25 * 32: dbout.dFormat = CF_TEXT
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
DevName = "/SITE/ENS/FEC.EXT"
For i% = 0 To 1
  rc = T_EXECLINK(DevName, FecName, dbout, txtbuf(0), dbin, 0, CA_READ + CA_RETRY, 600)
  If rc = 0 Then Exit For
Next
If rc Then GoTo exitFunction
MEMCPY finfo, txtbuf(0), Len(finfo)
pos% = Len(finfo)
For i% = 0 To 24
  MEMCPY eqpnames(i%).nam(0), txtbuf(pos%), 32
  pos% = pos% + 32
  If eqpnames(i%).nam(0) = 0 Then Exit For
Next
neqps = i%
ReDim eqps(neqps)
For i% = 0 To neqps - 1
  eqps(i%) = BSTR(eqpnames(i%).nam)
Next
exitFunction:
GetFecInfoFromNameServer = rc
End Function
Function GetFecsFromNameServer(ByVal context$, fecNames() As String, nfecs As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim fns(2000) As NAME16, cnt As NAME16
Dim DevName As String
Dim rc As Integer, i%
Dim Timeout As Integer
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
DevName = "/SITE/ENS"
If Len(context$) > 0 Then
  DevName = DevName + "/" + context$
End If
Timeout = 800
For i% = 0 To 1
  dbout.dArrayLength = 2000: dbout.dFormat = CF_NAME16
  rc = T_EXECLINK(DevName, "FECS", dbout, fns(0), dbin, 0, CA_READ + CA_RETRY, Timeout)
  If rc = 0 Then Exit For
  Timeout = Timeout * 2
Next
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim fecNames(n)
For i% = 0 To n - 1
  fecNames(i%) = Trim$(BSTR(fns(i%).nam()))
Next
exitFunction:
nfecs = n
GetFecsFromNameServer = rc%
End Function

Function GetFecFromDeviceServer(ByVal context As String, ByVal DeviceServer As String, FecName As String) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim fns As NAME16, cnt As NAME16, dsn As NAME32
Dim DevName As String
Dim rc As Integer, i%
Dim Timeout As Integer
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR dsn.nam, DeviceServer
DevName = "/SERVICE/ENS"
If Len(context$) > 0 Then
  DevName = DevName + "/" + context$
End If
Timeout = 800
For i% = 0 To 1
  dbout.dArrayLength = 1: dbout.dFormat = CF_NAME16
  rc = T_EXECLINK(DevName, "FECS", dbout, fns, dbin, dsn, CA_READ + CA_RETRY, Timeout)
  If rc = 0 Then Exit For
  Timeout = Timeout * 2
Next
If rc Then GoTo exitFunction
FecName = Trim$(BSTR(fns.nam()))
exitFunction:
GetFecFromDeviceServer = rc%
End Function

Function GetFecsFromNameServerEx(ByVal context$, ByVal subsys$, ByVal Importance$, fecNames() As String, fecos() As String, fecsub() As String, fecDesc() As String, fecEqp() As String, nfecs As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, K As Integer
Dim fns(2000) As USTRING, subs(1) As NAME16
Dim DevName As String
Dim rc As Integer, i%
Dim Timeout As Integer
Dim byteArray(80) As Byte
dbin.dArrayLength = 2: dbin.dFormat = CF_NAME16
BARR subs(0).nam, subsys$
BARR subs(1).nam, Importance$
DevName = "/SITE/ENS"
If Len(context$) > 0 Then
  DevName = DevName + "/" + context$
End If
Timeout = 800
For i% = 0 To 1
  dbout.dArrayLength = 2000: dbout.dFormat = CF_USTRING
  rc = T_EXECLINK(DevName, "FECS", dbout, fns(0), dbin, subs(0), CA_READ + CA_RETRY, Timeout)
  If rc = 0 Then Exit For
  Timeout = Timeout * 2
Next
If rc Then GoTo exitFunction
n = dbout.dArrayLength
ReDim fecNames(n)
ReDim fecos(n)
ReDim fecDesc(n)
ReDim fecsub(n)
ReDim fecEqp(n)
For i% = 0 To n - 1
  MEMCPY byteArray(0), fns(i%).STR(0), 16
  fecNames(i%) = Trim$(BSTR(byteArray))
  MEMCPY byteArray(0), fns(i%).STR(16), 8
  fecos(i%) = Trim$(BSTR(byteArray))
  MEMCPY byteArray(0), fns(i%).STR(24), 8
  fecsub(i%) = Trim$(BSTR(byteArray))
  MEMCPY byteArray(0), fns(i%).STR(32), 32
  fecEqp(i%) = Trim$(BSTR(byteArray))
'  Debug.Print fecEqp(i%)
  For K = 32 To 64
    If fns(i%).STR(K) = 0 Then Exit For
  Next
  MEMCPY byteArray(0), fns(i%).STR(K + 1), 79 - K
  fecDesc(i%) = Trim$(BSTR(byteArray))
Next
exitFunction:
nfecs = n
GetFecsFromNameServerEx = rc%
End Function

Function GetEquipmentDeviceContexts(devContexts() As String, nDevContexts As Integer) As Integer
Dim ldc(200) As NAME32
Dim n As Long, rc As Integer, i%

n = 200
rc = GetSystemContexts(ldc(0), n)
'rc = T_GETCONTEXTS(ldc(0), n)
If rc Then GoTo exitGetEquipmentDeviceContexts
ReDim devContexts(n)
For i% = 0 To n - 1
  devContexts(i%) = Trim$(BSTR(ldc(i%).nam()))
Next

exitGetEquipmentDeviceContexts:
nDevContexts = n
GetEquipmentDeviceContexts = rc

End Function
Function GetEquipmentDeviceServers(devcontext As String, devSubSystem As String, devservers() As String, nDevServers As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim srvs() As NAME32, subsys As NAME16
Dim DevName As String
Dim rc As Integer, i%
If Len(devSubSystem) = 0 Then
  dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
Else
  dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
  BARR subsys.nam(), Trim$(devSubSystem)
End If
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
DevName = "/SITE/ENS"
If Len(devcontext) > 0 Then DevName = DevName + "/" + devcontext
rc = T_EXECLINK(DevName, "NTAGS", dbout, n, dbin, subsys, CA_READ + CA_RETRY, 500)
If rc Then GoTo exitFunction
ReDim srvs(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME32
rc = T_EXECLINK(DevName, "TAGS", dbout, srvs(0), dbin, subsys, CA_READ + CA_RETRY, 3000)
If rc Then GoTo exitFunction
ReDim devservers(n)
For i% = 0 To n - 1
  devservers(i%) = Trim$(BSTR(srvs(i%).nam()))
Next
exitFunction:
nDevServers = n
GetEquipmentDeviceServers = rc%
End Function
Function SetRPCDragDropString(DevName$, DevProp$, devType%, devSize&, devDesc$) As String
SetRPCDragDropString = DevName$ & "!" & DevProp$ & "!" & Trim$(STR$(devType%)) _
                       & "!" & Trim$(STR$(devSize&)) & "!" & devDesc$
End Function
Function ParseRPCDragDropString(ddstr$, DevName$, DevProp$, devType%, devSize&, devDesc$) As Integer
Dim tmpstr$
Dim pos As Long

tmpstr$ = ddstr$
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
DevName$ = Left$(tmpstr$, pos)
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
DevProp$ = Left$(tmpstr$, pos)
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devType% = CInt(Left$(tmpstr$, pos))
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devSize& = CLng(Left$(tmpstr$, pos))
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
devDesc$ = tmpstr$

End Function
Function getLogFileEntries(ByVal SrvName As String, ByVal logName As String, entries() As String, Optional starttime As Variant, Optional stoptime As Variant)
Dim textblob(32000) As Byte
Dim blogfile(32) As Byte
Dim textstring As String
Dim textlines() As String
Dim dbout As DBLK
Dim dbin As DBLK
Dim rc As Integer
Dim n As Long, i As Long, sz As Long
Dim startt As Long, stopt As Long
Dim starti As Long, stopi As Long
Dim vtype As Integer
Dim useWholeFile As Boolean
Dim dt As Date
Dim ts As Long

If IsMissing(stoptime) Then
  stopt = UNIXTIME
Else
  vtype = VarType(stoptime)
  Select Case vtype
    Case vbLong:
      stopt = stoptime
    Case vbDate
      dt = stoptime
      stopt = DateToUnix(dt)
    Case Else
      stopt = UNIXTIME
  End Select
End If

If IsMissing(starttime) Then
  startt = 0
Else
  vtype = VarType(starttime)
  Select Case vtype
    Case vbLong:
      startt = starttime
    Case vbDate
      dt = starttime
      startt = DateToUnix(dt)
    Case Else
      startt = 0
  End Select
End If
If startt = 0 And stopt = UNIXTIME Then useWholeFile = True

dbout.dArrayLength = 32000
dbout.dFormat = CF_TEXT
dbin.dArrayLength = Len(logName)
dbin.dFormat = CF_TEXT

BARR blogfile, logName
rc = EXECLINKEx(SrvName, "SRVLOGFILE", dbout, textblob(0), dbin, blogfile(0), CA_READ, 3000)
If rc = 0 Then
  textstring = BSTR(textblob)
  If useWholeFile Then
    entries = Split(textstring, Chr(10))
  Else
    textlines = Split(textstring, Chr(10))
    For i = 1 To UBound(textlines) Step 1
      ts = getTimeStampFromLogEntry(textlines(i))
      If ts >= startt And starti = 0 Then
        starti = i
      End If
      If ts >= stopt And stopi = 0 Then
        stopi = i
        Exit For
      End If
    Next
    If stopi = 0 Then stopi = UBound(textlines)
    ReDim entries(stopi - starti)
    For i = starti To stopi
      If Len(textlines(i)) > 32 Then
        entries(i - starti) = textlines(i)
      End If
    Next
  End If
End If
getLogFileEntries = rc
End Function
Function DateToUnix(vbDate As Date) As Long
Dim ut As Long
Dim t As TM
'Debug.Print vbDate
t.tm_year = Year(vbDate)
t.tm_mon = Month(vbDate)
t.tm_mday = Day(vbDate)
t.tm_hour = Hour(vbDate)
t.tm_min = Minute(vbDate)
t.tm_sec = Second(vbDate)
t.tm_isdst = -1
ut = MKTIME(t)
'Debug.Print ASCTIME(ut)
DateToUnix = ut
End Function


Function getTimeStampFromLogEntry(ByVal textline As String) As Long
Dim t As TM
Dim ut As Long
Dim ts As String
Dim p As Long
If Len(textline) < 32 Then
  ' line fragment : skip it
  getTimeStampFromLogEntry = 0
  Exit Function
End If
If Left$(textline, 1) = "[" Then
  'old style ? ends with : 01/20/05-10:17:48
  ts = Right$(textline, 17)
  If Mid(ts, 3, 1) <> "/" Then
    ut = 0
  Else
    t.tm_mon = Val(Left$(ts, 2))
    t.tm_mday = Val(Mid$(ts, 4, 2))
    t.tm_year = Val(Mid$(ts, 7, 2)) + 2000
    t.tm_hour = Val(Mid$(ts, 10, 2))
    t.tm_min = Val(Mid$(ts, 13, 2))
    t.tm_sec = Val(Mid$(ts, 16, 2))
    t.tm_isdst = -1
    ut = MKTIME(t)
  End If
  getTimeStampFromLogEntry = ut
  Exit Function
End If
p = InStr(1, textline, "200")
If p > 0 And Mid$(textline, p + 4, 1) = "-" And Mid$(textline, p + 7, 1) = "-" Then
  '2005-01-18 17:00:02
  ts = Mid$(textline, p, 19)
  t.tm_mon = Val(Mid$(ts, 6, 2))
  t.tm_mday = Val(Mid$(ts, 9, 2))
  t.tm_year = Val(Left$(ts, 4))
  t.tm_hour = Val(Mid$(ts, 12, 2))
  t.tm_min = Val(Mid$(ts, 15, 2))
  t.tm_sec = Val(Mid$(ts, 18, 2))
  t.tm_isdst = -1
  ut = MKTIME(t)
  getTimeStampFromLogEntry = ut
  Exit Function
End If
'starts with : 17.01.05 22:19:06.453 CET
t.tm_mday = Val(Left$(textline, 2))
t.tm_mon = Val(Mid$(textline, 4, 2))
t.tm_year = Val(Mid$(textline, 7, 2)) + 2000
t.tm_hour = Val(Mid$(textline, 10, 2))
t.tm_min = Val(Mid$(textline, 13, 2))
t.tm_sec = Val(Mid$(textline, 16, 2))
t.tm_isdst = IIf(Right$(textline, 2) = "DT", 1, 0)
ut = MKTIME(t)
getTimeStampFromLogEntry = ut
End Function
Function MAKETIME(yr As Integer, mo As Integer, da As Integer, hr As Integer, se As Integer) As Long
Static t As TM
t.tm_hour = hr Mod 24
t.tm_mday = da
t.tm_mon = mo
t.tm_year = yr
t.tm_sec = se
MAKETIME = MKTIME(t)
End Function

Function GetShiftFromMask(ByVal Mask As Long, ByVal fmt As Integer) As Long
Dim shf As Long, mshf As Long, B As Long
Dim i As Integer
B = 1
mshf = GetFormatSize(fmt) * 8 - 1
While (Mask And B) = 0 And shf < mshf
  shf = shf + 1
  B = B * 2
Wend
GetShiftFromMask = shf
End Function
