#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
#include "eventlst.h"
#include "srvlst.h"
#include "arceqm.h"

/*
   The code section below illustrates how one registers a structure
   to be exported.  All network structures should come in and go out
   int INTEL byte order with 1-byte allignment.  INTEL to INTEL does
   not need to swap.

   Note the use of the short "reserved" in the structure below.
   Although not necessary, it is strongly recommended that you
   assume structures to be alligned on 4-byte boundaries and fill
   in any gaps with reserved or dummy tags.  This will make life
   much easier in Visual Basic 4.0 (32-bit) where structures are
   by definition alligned on 4-byte boundaries.  If you don't follow
   this suggestion, then you will have to (in Visual basic 4.0) read
   your structure into a byte array and parse it out into your
   desired VB structure.
*/

#define dumpStructInfo(tag) {\
  if ((s=getStructFromTag(tag)) != NULL) {\
    printf("%s: num %d size %d rawlen %d\n",tag,s->num,s->size,s->rawlen);\
  } else printf("%s: not found\n",tag);\
}
#define quit(i) { printf("ABORT: %s\n",erlst[i]); exit(1); }
void registerStructs(void)
{
  /* this must follow the order of the structure explicitly! */

  if (addFieldToStruct("AESNOT",OFFSETIN(AESnotify,version),1,CF_LONG,"version")) quit(out_of_local_memory);
  if (addFieldToStruct("AESNOT",OFFSETIN(AESnotify,eventNumber),1,CF_LONG,"eventNumber")) quit(out_of_local_memory);
  if (addFieldToStruct("AESNOT",OFFSETIN(AESnotify,eventCode),1,CF_LONG,"eventCode")) quit(out_of_local_memory);
  if (addFieldToStruct("AESNOT",OFFSETIN(AESnotify,reserved),1,CF_LONG,"reserved")) quit(out_of_local_memory);
  if (addFieldToStruct("AESNOT",OFFSETIN(AESnotify,comment),4*64,CF_TEXT,"comment")) quit(out_of_local_memory);
  if (sealTaggedStruct("AESNOT",sizeof(AESnotify),1)) quit(out_of_local_memory);

  if (addFieldToStruct("AESCON",OFFSETIN(AEScontext,version),1,CF_LONG,"version")) quit(out_of_local_memory);
  if (addFieldToStruct("AESCON",OFFSETIN(AEScontext,eventNumber),1,CF_LONG,"eventNumber")) quit(out_of_local_memory);
  if (addFieldToStruct("AESCON",OFFSETIN(AEScontext,eventCode),1,CF_LONG,"eventCode")) quit(out_of_local_memory);
  if (addFieldToStruct("AESCON",OFFSETIN(AEScontext,reserved),1,CF_LONG,"reserved")) quit(out_of_local_memory);
  if (addFieldToStruct("AESCON",OFFSETIN(AEScontext,deviceName),16,CF_TEXT,"deviceName")) quit(out_of_local_memory);
  if (sealTaggedStruct("AESCON",sizeof(AEScontext),1)) quit(out_of_local_memory);

  if (addFieldToStruct("AES",OFFSETIN(AES,eventNumber),1,CF_LONG,"eventNumber")) quit(out_of_local_memory);
  if (addFieldToStruct("AES",OFFSETIN(AES,eventCode),1,CF_LONG,"eventCode")) quit(out_of_local_memory);
  if (addFieldToStruct("AES",OFFSETIN(AES,comment),4*64,CF_TEXT,"comment")) quit(out_of_local_memory);
  if (addFieldToStruct("AES",OFFSETIN(AES,dsMask),32,CF_BYTE,"dsMask")) quit(out_of_local_memory);
  if (sealTaggedStruct("AES",sizeof(AES),100)) quit(out_of_local_memory);

  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,eventNumber),1,CF_LONG,"eventNumber")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,starttime),1,CF_LONG,"starttime")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,stoptime),1,CF_LONG,"stoptime")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,devSpecifier.deviceServerName),16,CF_TEXT,"deviceServerName")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,devSpecifier.deviceProperty),16,CF_TEXT,"deviceProperty")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,devSpecifier.deviceName),16,CF_TEXT,"deviceName")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,devSpecifier.dataFormat),1,CF_SHORT,"dataFormat")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRB",OFFSETIN(ADRB,devSpecifier.dataDimension),1,CF_SHORT,"dataDimension")) quit(out_of_local_memory);
  if (sealTaggedStruct("ADRB",sizeof(ADRB),1)) quit(out_of_local_memory);

  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,eventNumber),1,CF_LONG,"eventNumber")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,starttime),1,CF_LONG,"starttime")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,stoptime),1,CF_LONG,"stoptime")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.deviceContext),16,CF_TEXT,"deviceContext")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.deviceServerName),16,CF_TEXT,"deviceServerName")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.deviceProperty),32,CF_TEXT,"deviceProperty")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.deviceName),32,CF_TEXT,"deviceName")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.dataFormat),1,CF_SHORT,"dataFormat")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.reserved),1,CF_SHORT,"reserved")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.dataIndex),1,CF_LONG,"dataIndex")) quit(out_of_local_memory);
  if (addFieldToStruct("ADRBX",OFFSETIN(ADRBX,devSpecifier.dataDimension),1,CF_LONG,"dataDimension")) quit(out_of_local_memory);
  if (sealTaggedStruct("ADRBX",sizeof(ADRBX),1)) quit(out_of_local_memory);

  if (addFieldToStruct("AIB",OFFSETIN(AIB,numProperties),1,CF_SHORT,"numProperties")) quit(out_of_local_memory);
  if (addFieldToStruct("AIB",OFFSETIN(AIB,numDevices),1,CF_SHORT,"numDevices")) quit(out_of_local_memory);
  if (addFieldToStruct("AIB",OFFSETIN(AIB,eventCode),1,CF_LONG,"eventCode")) quit(out_of_local_memory);
  if (addFieldToStruct("AIB",OFFSETIN(AIB,comment),64,CF_TEXT,"comment")) quit(out_of_local_memory);
  if (sealTaggedStruct("AIB",sizeof(AIB),1)) quit(out_of_local_memory);

  if (addFieldToStruct("PIB",OFFSETIN(PIB,SamplingRate),1,CF_FLOAT,"SamplingRate")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,numPreTriggerValues),1,CF_LONG,"numPreTriggerValues")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,TimeOffset),1,CF_LONG,"TimeOffset")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,LowCount),1,CF_LONG,"LowCount")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,HighCount),1,CF_LONG,"HighCount")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,Units),16,CF_TEXT,"Units")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,LowEGU),1,CF_DOUBLE,"LowEGU")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,HighEGU),1,CF_DOUBLE,"HighEGU")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,numDevices),1,CF_SHORT,"numDevices")) quit(out_of_local_memory);
  if (addFieldToStruct("PIB",OFFSETIN(PIB,reserved),1,CF_SHORT,"reserved")) quit(out_of_local_memory);
  if (sealTaggedStruct("PIB",sizeof(PIB),1)) quit(out_of_local_memory);

  if (addFieldToStruct("DHS",OFFSETIN(DHS,channelID),32,CF_TEXT,"channelID")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,eventcode),1,CF_LONG,"eventcode")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,arraysize),1,CF_SHORT,"arraysize")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,datatype),1,CF_SHORT,"datatype")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,samplingrate),1,CF_FLOAT,"samplingrate")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,pretrigger),1,CF_LONG,"pretrigger")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,timeoffset),1,CF_LONG,"timeoffset")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,lowcount),1,CF_LONG,"lowcount")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,highcount),1,CF_LONG,"highcount")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,egu),16,CF_TEXT,"egu")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,egulow),1,CF_FLOAT,"egulow")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,eguhigh),1,CF_FLOAT,"eguhigh")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,datalength),1,CF_LONG,"datalength")) quit(out_of_local_memory);
  if (addFieldToStruct("DHS",OFFSETIN(DHS,desc),4*64,CF_TEXT,"desc")) quit(out_of_local_memory);
  if (sealTaggedStruct("DHS",sizeof(DHS),1)) quit(out_of_local_memory);

  if (addFieldToStruct("HEADER",OFFSETIN(DHS,channelID),32,CF_TEXT,"channelID")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,eventcode),1,CF_LONG,"eventcode")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,arraysize),1,CF_SHORT,"arraysize")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,datatype),1,CF_SHORT,"datatype")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,samplingrate),1,CF_FLOAT,"samplingrate")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,pretrigger),1,CF_LONG,"pretrigger")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,timeoffset),1,CF_LONG,"timeoffset")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,lowcount),1,CF_LONG,"lowcount")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,highcount),1,CF_LONG,"highcount")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,egu),16,CF_TEXT,"egu")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,egulow),1,CF_FLOAT,"egulow")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,eguhigh),1,CF_FLOAT,"eguhigh")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,datalength),1,CF_LONG,"datalength")) quit(out_of_local_memory);
  if (addFieldToStruct("HEADER",OFFSETIN(DHS,desc),4*64,CF_TEXT,"desc")) quit(out_of_local_memory);
  if (sealTaggedStruct("HEADER",sizeof(DHS),1)) quit(out_of_local_memory);

  return;
}

