VERSION 5.00
Object = "{4727FED0-D8EC-11D0-B104-0000E80D9CC1}#1.0#0"; "srv.ocx"
Begin VB.Form Form1 
   Caption         =   "Sine Curve Generator"
   ClientHeight    =   1845
   ClientLeft      =   60
   ClientTop       =   375
   ClientWidth     =   4725
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1845
   ScaleWidth      =   4725
   StartUpPosition =   3  'Windows Default
   Begin SRVLib.Srv Srv1 
      Left            =   120
      Top             =   1200
      _Version        =   65536
      _ExtentX        =   979
      _ExtentY        =   979
      _StockProps     =   64
   End
   Begin VB.Timer Timer1 
      Interval        =   200
      Left            =   780
      Top             =   1320
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Height          =   825
      Left            =   150
      TabIndex        =   0
      Top             =   210
      Width           =   4395
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Const NUM_DEVICES = 10
Private Const NUM_VALUES = 1024 * 8

Private Type SineInfo
  amplitude As Single
  frequency As Single
  noise As Single
  phase As Single
  numberCalls As Long
  Description(63) As Byte
End Type


Dim sineInfoTable(NUM_DEVICES - 1) As SineInfo
Dim sinbuf(NUM_VALUES - 1, NUM_DEVICES - 1) As Single

Dim sinname(NUM_DEVICES - 1) As String

Sub RegisterStructs()
  Dim offset As Long
  ' this must follow the order of the structure explicitly!
  ' note: in VB the alignment is always 4-bytes (do not leave alignment gaps!)
  '       offset is then always the accumulated size in bytes (Len) of the structure fields
  AddFieldToStruct "SineInfo", offset, 1, CF_FLOAT, "amplitude"
  offset = offset + Len(sineInfoTable(0).amplitude)
  AddFieldToStruct "SineInfo", offset, 1, CF_FLOAT, "frequency"
  offset = offset + Len(sineInfoTable(0).frequency)
  AddFieldToStruct "SineInfo", offset, 1, CF_FLOAT, "noise"
  offset = offset + Len(sineInfoTable(0).noise)
  AddFieldToStruct "SineInfo", offset, 1, CF_FLOAT, "phase"
  offset = offset + Len(sineInfoTable(0).phase)
  AddFieldToStruct "SineInfo", offset, 1, CF_LONG, "numberCalls"
  offset = offset + Len(sineInfoTable(0).numberCalls)
  AddFieldToStruct "SineInfo", offset, 64, CF_TEXT, "Description"
  ' terminate the registration :
  SealTaggedStruct "SineInfo", Len(sineInfoTable(0)), NUM_DEVICES

End Sub

Sub ServerInit()
Dim i As Integer, cc As Integer

On Error GoTo initError
SetIgnoreCommonFiles True
' some startup parameters ...
For i = 0 To NUM_DEVICES - 1
  sinname(i) = "SineGen" + Trim(STR(i))
  sineInfoTable(i).amplitude = 256#
  sineInfoTable(i).frequency = 1#
  sineInfoTable(i).phase = 0#
  sineInfoTable(i).noise = 30#
  BARR sineInfoTable(i).Description, "Sine Generator " + STR(i) + " at your disposal"
Next
'register the sine info struct
Call RegisterStructs

cc = SetCycleDelay(0)
cc = SetMinimumPollingRate(50)

' register the fec name and port here in code:
cc = RegisterFecNameEx("VBSINESRV.18", "[TEST]Sine Generator", "my office", "none", "me", 18, "TEST")

Srv1.EqpName = "SINEQM"
Srv1.ExportName = "VbSineServer"
Srv1.EqpNumberModules = NUM_DEVICES
' enable the server
Srv1.Enabled = True
If Srv1.EqpStatus = 0 Then
  Label1.Caption = "Sine Generator Server is running"
  Label1.BackColor = vbGreen
Else
  Label1.Caption = "Sine Generator Server not is running : " + RPCERROR(Srv1.EqpStatus)
  Label1.BackColor = vbRed
End If
' now register the properties and devices ...

cc = Srv1.EqpRegisterPropertyEx("Sine", 0, CF_NULL, "", NUM_VALUES, CF_FLOAT, "", CA_READ + CA_NETWORK, "[-1000:1000 V][0:1000 ms]Sine Curve")
cc = Srv1.EqpRegisterPropertyEx("Amplitude", 1, CF_FLOAT, "", NUM_DEVICES, CF_FLOAT, "", CA_READ + CA_WRITE, "[1:1000 V][CHANNEL]Sine Curve Amplitude")
cc = Srv1.EqpRegisterPropertyEx("Frequency", 1, CF_FLOAT, "", NUM_DEVICES, CF_FLOAT, "", CA_READ + CA_WRITE, "[1:60 Hz][CHANNEL]Sine Curve Frequency")
cc = Srv1.EqpRegisterPropertyEx("Phase", 1, CF_FLOAT, "", NUM_DEVICES, CF_FLOAT, "", CA_READ + CA_WRITE, "[1:512][CHANNEL]Sine Curve Phase")
cc = Srv1.EqpRegisterPropertyEx("Noise", 1, CF_FLOAT, "", NUM_DEVICES, CF_FLOAT, "", CA_READ + CA_WRITE, "[0:100 V][CHANNEL]Sine Curve Noise")
cc = Srv1.EqpRegisterPropertyEx("SineInfo", 1, CF_STRUCT, "SineInfo", NUM_DEVICES, CF_STRUCT, "SineInfo", CA_READ + CA_WRITE, "Sine Curve Information")

For i = 0 To NUM_DEVICES - 1
  cc = Srv1.EqpRegisterModule(sinname(i), i)
Next

Label1.Caption = "status = " + STR(SRVSTATUS)
Exit Sub
initError:
MsgBox Error(Err), vbOKOnly, "Initialization Error"
End Sub

Sub UpdateSine(ByVal devnr As Integer)
  Dim i As Integer, k As Integer
  ' float *target = sinbuf[devnr];
  Dim f As Single, a As Single
  Dim n As Integer, p As Integer
  f = sineInfoTable(devnr).frequency
  n = sineInfoTable(devnr).noise
  p = sineInfoTable(devnr).phase
  a = sineInfoTable(devnr).amplitude

  For i = 0 To NUM_VALUES - 1
    k = (i + p) Mod NUM_VALUES
    sinbuf(i, devnr) = n * Rnd + (Sin(f * i * 6.2832 / (NUM_VALUES / 8)) * a)
  Next
  
End Sub


Private Sub Form_Load()
Call ServerInit
End Sub

Private Sub Srv1_EqpFcn(ByVal DevName As String, ByVal devProperty As String, ByVal outArrayLen As Long, ByVal inArrayLen As Long, ByVal devAccess As Integer)
  Dim devnr As Integer, i As Integer, cc As Integer
  Dim mcarray(NUM_DEVICES - 1) As Single
  Dim fval As Single
  Dim sinf As SineInfo

  devnr = Srv1.EqpGetModuleNumber(DevName)
  If (devnr < 0 Or devnr >= NUM_DEVICES) Then
    Srv1.EqpSetCompletion illegal_equipment_number, ""
    Exit Sub
  End If

  Select Case devProperty
    Case "Sine":
        If (devAccess And CA_WRITE) = CA_WRITE Then
          Srv1.EqpSetCompletion illegal_read_write, ""
          Exit Sub
        End If
        Srv1.EqpSendData sinbuf(0, devnr)
        sineInfoTable(devnr).numberCalls = sineInfoTable(devnr).numberCalls + 1
    Case "Amplitude":
        If (inArrayLen > 0) Then
          If (devAccess And CA_WRITE) <> CA_WRITE Then
            Srv1.EqpSetCompletion illegal_read_write, ""
            Exit Sub
          End If
          Srv1.EqpRecvData fval
          If fval < 1 Or fval > 500 Then
            Srv1.EqpSetCompletion out_of_range, ""
            Exit Sub
          End If
          sineInfoTable(devnr).amplitude = fval
        End If
        If (outArrayLen > 0) Then
        ' /* prepare multichannel array */
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).amplitude
            Srv1.EqpSendDataEx mcarray(devnr), NUM_DEVICES - devnr
          Next
        End If
    Case "Frequency":
        If (inArrayLen > 0) Then
          If (devAccess And CA_WRITE) <> CA_WRITE Then
            Srv1.EqpSetCompletion illegal_read_write, ""
            Exit Sub
          End If
          Srv1.EqpRecvData fval
          If fval < 1 Or fval > 100 Then
            Srv1.EqpSetCompletion out_of_range, ""
            Exit Sub
          End If
          sineInfoTable(devnr).frequency = fval
        End If
        If (outArrayLen > 0) Then
        ' /* prepare multichannel array */
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).frequency
            Srv1.EqpSendDataEx mcarray(devnr), NUM_DEVICES - devnr
          Next
        End If
    Case "Phase":
        If (inArrayLen > 0) Then
          If (devAccess And CA_WRITE) <> CA_WRITE Then
            Srv1.EqpSetCompletion illegal_read_write, ""
            Exit Sub
          End If
          Srv1.EqpRecvData fval
          If fval < 1 Or fval > 512 Then
            Srv1.EqpSetCompletion out_of_range, ""
            Exit Sub
          End If
          sineInfoTable(devnr).phase = fval
        End If
        If (outArrayLen > 0) Then
        ' /* prepare multichannel array */
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).phase
            Srv1.EqpSendDataEx mcarray(devnr), NUM_DEVICES - devnr
          Next
        End If
    Case "Noise":
        If (inArrayLen > 0) Then
          If (devAccess And CA_WRITE) <> CA_WRITE Then
            Srv1.EqpSetCompletion illegal_read_write, ""
            Exit Sub
          End If
          Srv1.EqpRecvData fval
          If fval < 1 Or fval > 100 Then
            Srv1.EqpSetCompletion out_of_range, ""
            Exit Sub
          End If
          sineInfoTable(devnr).noise = fval
        End If
        If (outArrayLen > 0) Then
        ' /* prepare multichannel array */
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).noise
            Srv1.EqpSendDataEx mcarray(devnr), NUM_DEVICES - devnr
          Next
        End If
    Case "SineInfo":
        If (inArrayLen > 0) Then
          If (devAccess And CA_WRITE) <> CA_WRITE Then
            Srv1.EqpSetCompletion illegal_read_write, ""
            Exit Sub
          End If
        ' /* allow an atomic set of all relevant values this way : */
          cc = 0
          Srv1.EqpRecvData sinf.amplitude
          If (sinf.amplitude < 1 Or sinf.amplitude > 1000) Then cc = out_of_range
          If (sinf.frequency < 1 Or sinf.frequency > 100) Then cc = out_of_range
          If (sinf.phase < 1 Or sinf.phase > 512) Then cc = out_of_range
          If (sinf.noise < 1 Or sinf.noise > 100) Then cc = out_of_range
          If cc <> 0 Then
            Srv1.EqpSetCompletion cc, ""
            Exit Sub
          End If
          sineInfoTable(devnr) = sinf
        End If
        If (outArrayLen > 0) Then
          Srv1.EqpSendData sineInfoTable(0).amplitude
        End If
    Case Else:
        Srv1.EqpSetCompletion illegal_property, ""
        Exit Sub
  End Select
  
  Srv1.EqpSetCompletion 0, ""

End Sub

Private Sub Timer1_Timer()
Dim i As Integer
For i = 0 To NUM_DEVICES - 1
  Call UpdateSine(i)
Next
End Sub


